package controll;

import gui.MainFrame;
import gui.report.CaseEditorMainPanel;
import gui.search.Search;
import gui.statistic.Statistic;
import gui.suchen.graph.DefaultGraphUI;
import io.OntmanagerAccess;
import io.SQLDBAccess;
import io.XMLDBAccess;
import services.coordination.Parameter;
import services.coordination.ServiceCoordinator;
import services.coordination.ServiceID;
import services.coordination.ServiceProvider;
import services.similarity.SimilarReportsSearch;
import services.suchen.SuchService;

public class MainControll {

	private static Statistic statisticp;
	private static Search searchp;
	private static CaseEditorMainPanel reportmainp;
	private static CaseEditorControll casecontroll;
	private static MainFrame mf;
	public static final ServiceCoordinator SERVICECOORDINATOR = new ServiceCoordinator();
	public static final DefaultGraphUI DEFAULT_GRAPH_UI = new DefaultGraphUI();

	public static void init(MainFrame m) {
		XMLDBAccess.initConnection();
		SQLDBAccess.initConnection();

		//OntmanagerAccess ont = new OntmanagerAccess();
		//OntmanagerAccess.initConnection();
		//ont.init();
		JenaControll.init();
		RelationCacheControll.init();

		// SQLDBAccess.fillDB(null);
		mf = m;
		casecontroll = new CaseEditorControll();
		initServiceCoordinator();
		searchp = new Search();
		statisticp = new Statistic();
		reportmainp = new CaseEditorMainPanel();
		CaseEditorControll.init(reportmainp);
	}

	public static void initServiceCoordinator() {

		SERVICECOORDINATOR.registerServiceProvider(new ServiceProvider() {
			public void performService(ServiceID serviceType, Parameter param) {
				new SuchService().runOntologieSuche(param);
			}
		}, ServiceID.RUN_ONTOLOGY_SEARCH);

		SERVICECOORDINATOR.registerServiceProvider(new ServiceProvider() {
			public void performService(ServiceID serviceType, Parameter param) {
				new SuchService().runReportSuche(param);
			}
		}, ServiceID.PERFORM_REPORT_SEARCH);

		SERVICECOORDINATOR.registerServiceProvider(new SimilarReportsSearch(),
				ServiceID.PERFORM_SIMILARITY_SEARCH);

		SERVICECOORDINATOR.registerServiceProvider(casecontroll,
				ServiceID.SHOW_UI_REPORT);
	}

	public static void showCaseEditorPanel() {
		mf.changeMainPanel(reportmainp);
		reportmainp.repaint();
	}

	public static void showStatisticPanel() {
		mf.changeMainPanel(statisticp);
		statisticp.repaint();
	}

	public static void showSearchPanel() {
		mf.changeMainPanel(searchp);
		searchp.repaint();
	}
}
