package gui;

import java.awt.BorderLayout;
import java.awt.Color;
import java.awt.Dimension;
import java.awt.Font;
import java.util.logging.Logger;

import javax.swing.JFrame;
import javax.swing.JPanel;
import javax.swing.UIManager;

import controll.MainControll;

public class MainFrame extends JFrame {

	private JPanel mainpanel = new JPanel();
	
	public MainFrame() {
		MainControll.init(this);
		this.setTitle("Semantic Web der Pathologie");
		this.setLocation(0,0);
	
	//	this.setResizable(false);
		this.setContentPane(new JPanel(new BorderLayout()));
		this.getContentPane().add(new Navi(), "West");
		
		this.getContentPane().add(mainpanel = new JPanel(), "Center");
		
	
		this.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
		konfiguriereLookAndFeel();
		this.pack();
		this.setVisible(true);
	}
	
	public void changeMainPanel(MainPanel newComponent){
		mainpanel.removeAll();
		mainpanel.add(newComponent);
		this.pack();
		
	}
	
	private static void konfiguriereLookAndFeel() {
		try {
			String systemLookAndFeelClassName = UIManager.getSystemLookAndFeelClassName();
			UIManager.setLookAndFeel(systemLookAndFeelClassName);
			UIManager.put("TitledBorder.font", new Font("Verdana", Font.BOLD, 12));
			Color defaultBackground = new Color(236, 233, 226);

		/*	UIManager.put("Viewport.background", defaultBackground);
			UIManager.put("OptionPane.background", defaultBackground);
			UIManager.put("Desktop.background", defaultBackground);
			UIManager.put("List.background", defaultBackground);
			UIManager.put("Menu.background", defaultBackground);
			UIManager.put("MenuBar.background", defaultBackground);
			UIManager.put("MenuItem.background", defaultBackground);
			UIManager.put("JPanel.background", defaultBackground);
			UIManager.put("RadioButton.background", defaultBackground);
			UIManager.put("CheckBox.background", defaultBackground);
			UIManager.put("Slider.background", defaultBackground);
			UIManager.put("Label.background", defaultBackground);
			UIManager.put("ScrollPane.background", defaultBackground);
			UIManager.put("Button.background", defaultBackground);
			UIManager.put("CaseEditorMainPanel.background", defaultBackground);
			UIManager.put("JTabbedPane.background", defaultBackground);*/
			
		}
		catch (Exception _) {
			Logger.global.warning("System Look and Feel nicht gefunden.");
		}
	}
	
	
	public static void main(String[] args) {
		MainFrame m = new MainFrame();
	}

}
