package gui;

import gui.report.image.ImageDisplay;
import io.SQLDBAccess;

import java.awt.GridBagConstraints;
import java.awt.GridBagLayout;
import java.awt.GridLayout;
import java.awt.Insets;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;

import javax.media.jai.JAI;
import javax.swing.JButton;
import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.JProgressBar;

import services.coordination.Parameter;
import services.coordination.ServiceID;
import services.coordination.ServiceProvider;
import services.suchen.FortschrittInfo;



import controll.MainControll;

public class Navi extends JPanel implements ServiceProvider{
	
	private final JProgressBar	progressBar	= new JProgressBar();

	public Navi() {
		JButton reportedit, search, statistic, fill;
		/*
		 * this.setLayout(new GridLayout(20, 1));
		 * 
		 * ((GridLayout) (this.getLayout())).setHgap(10);
		 * 
		 * 
		 * ((GridLayout) (this.getLayout())).setVgap(10);
		 */

	/*	ImageDisplay logoPanel = new ImageDisplay(JAI.create("url", 
				
				
				getClass().getResource(
				Constants.SWPATHO_LOGO)))
				
				;
			ImageDisplay uniPanel = new ImageDisplay(JAI.create("url", 
					
					
					getClass().getResource(
				Constants.UNI_LOGOS)));*/
		
		
		this.setLayout(new GridBagLayout());

		
		this.add(new JPanel(),
				
				new GridBagConstraints(0, 0, 5, 1, 0.0, 0.0, GridBagConstraints.CENTER,
						GridBagConstraints.BOTH, new Insets(5, 5, 5, 20), 0, 0));
		
		
		this.add(new JLabel("Hauptfunktionen", JLabel.CENTER),

		new GridBagConstraints(0, 1, 5, 1, 0.0, 0.0, GridBagConstraints.CENTER,
				GridBagConstraints.BOTH, new Insets(5, 5, 5, 20), 0, 0));
		this.add(reportedit = new JButton("Befundeditor"),
				new GridBagConstraints(1, 2, 3, 1, 0.0, 0.0,
						GridBagConstraints.CENTER, GridBagConstraints.BOTH,
						new Insets(5, 5, 5, 20), 0, 0));

		this.add(search = new JButton("Suchen"), new GridBagConstraints(1, 3,
				3, 1, 0.0, 0.0, GridBagConstraints.CENTER,
				GridBagConstraints.BOTH, new Insets(5, 5, 5, 20), 0, 0));
		this.add(statistic = new JButton("Statistiken"),
				new GridBagConstraints(1, 4, 3, 1, 0.0, 0.0,
						GridBagConstraints.CENTER, GridBagConstraints.BOTH,
						new Insets(5, 5, 5, 20), 0, 0));

		this.add(new JPanel(),

		new GridBagConstraints(0, 5, 5, 3, 1.0, 1.0, GridBagConstraints.CENTER,
				GridBagConstraints.BOTH, new Insets(5, 5, 5, 20), 0, 0));
		
		
		this.add(new JLabel("Testfunktionen", JLabel.CENTER),
				new GridBagConstraints(0, 8, 5, 1, 0.0, 0.0,
						GridBagConstraints.CENTER, GridBagConstraints.BOTH,
						new Insets(5, 5, 5, 20), 0, 0));
		
		
		this.add(fill = new JButton("DatenBank Fuellen"),
				new GridBagConstraints(1, 9, 3, 1, 0.0, 0.0,
						GridBagConstraints.CENTER, GridBagConstraints.BOTH,
						new Insets(5, 5, 5, 20), 0, 0));
		
		this.add(new JPanel(),new GridBagConstraints(0, 10, 5, 5, 1.0, 1.0,
				GridBagConstraints.CENTER, GridBagConstraints.BOTH,
				new Insets(5, 5, 5, 20), 0, 0));
				
		this.add(progressBar,new GridBagConstraints(1, 15, 3, 1, 0.0, 0.0,
				GridBagConstraints.CENTER, GridBagConstraints.BOTH,
				new Insets(5, 5, 5, 20), 0, 0));

		/*
		 * this.add(new JLabel("Hauptfunktionen", JLabel.CENTER));
		 * 
		 * JPanel report_p, search_p, statistic_p, fill_p; this.add(report_p =
		 * new JPanel()); report_p.add(reportedit = new
		 * JButton("Befundeditor"));
		 * 
		 * this.add(search_p = new JPanel()); search_p.add(search = new
		 * JButton("Suchen"));
		 * 
		 * this.add(statistic_p = new JPanel()); statistic_p.add(statistic = new
		 * JButton("Statistiken"));
		 * 
		 * this.add(new JLabel());
		 * 
		 * this.add(new JLabel("Testfunktionen", JLabel.CENTER));
		 * 
		 * this.add(fill_p = new JPanel()); fill_p.add(fill = new
		 * JButton("DatenBank Fuellen"));
		 */
		// fill.setEnabled(false);

		fill.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent arg0) {
				SQLDBAccess.fillDB(null);

			}

		});

		reportedit.addActionListener(new ActionListener() {
			public void actionPerformed(java.awt.event.ActionEvent arg0) {
				MainControll.showCaseEditorPanel();
			};
		});
		search.addActionListener(new ActionListener() {
			public void actionPerformed(java.awt.event.ActionEvent arg0) {
				MainControll.showSearchPanel();
			};
		});
		statistic.addActionListener(new ActionListener() {
			public void actionPerformed(java.awt.event.ActionEvent arg0) {
				MainControll.showStatisticPanel();
			};
		});
		
		
		
		MainControll.SERVICECOORDINATOR.registerServiceProvider(this, ServiceID.SHOW_PROGRESS);

	}
	
	
	public synchronized void performService(ServiceID serviceType, Parameter param) {
		// Preconditions:
		assert serviceType != null;
		assert param != null;

		// Implementation:
		FortschrittInfo info = (FortschrittInfo) param.value;
		final boolean start = info.getIsStarting();
		progressBar.setString(start ? info.getMessage() : "");
		if (start != progressBar.isIndeterminate()) {
			progressBar.setIndeterminate(start);
		}
	}
	

}
