package gui;

import java.awt.BorderLayout;
import java.awt.Dimension;
import java.awt.Frame;
import java.awt.GridBagConstraints;
import java.awt.GridBagLayout;
import java.awt.Insets;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.KeyAdapter;
import java.awt.event.KeyEvent;
import java.awt.event.WindowEvent;

import javax.swing.JButton;
import javax.swing.JDialog;
import javax.swing.JList;
import javax.swing.JPanel;
import javax.swing.JScrollPane;
import javax.swing.ListSelectionModel;

public class OpenDialog extends JDialog {

	private boolean okButtonPressed = false;

	private JPanel panel1 = new JPanel(), jPanel1 = new JPanel();

	private JList jList1 = new JList();

	private JButton okButton = new JButton(), cancelButton = new JButton();

	private JScrollPane jScrollPane1 = new JScrollPane();

	public OpenDialog(Frame frame, String title, boolean modal) {
		super(frame, title, modal);
		try {
			jbInit();
			pack();
		} catch (Exception ex) {
			ex.printStackTrace();
		}
	}

	public OpenDialog(Frame frame, String[] items) {
		this(frame, "Open report...", true);
		jList1.setListData(items);
		this.setName("Open report");
	}

	private void jbInit() throws Exception {
		panel1.setLayout(new GridBagLayout());
		jList1.setAutoscrolls(true);
		jList1.setMinimumSize(new Dimension(50, 50));
		jList1.setSelectionMode(ListSelectionModel.SINGLE_SELECTION);
		jList1.addKeyListener(new KeyAdapter() {
			public void keyPressed(KeyEvent arg0) {
				if (arg0.getKeyCode() == KeyEvent.VK_ENTER) {
					okButtonPressed = true;
					cancel();
				}
			}
		});
		okButton.setText("OK");
		okButton.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent arg0) {
				okButtonPressed = true;
				cancel();
			}
		});
		cancelButton.setText("Cancel");
		cancelButton.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent arg0) {
				cancel();
			}
		});
		this
				.setDefaultCloseOperation(javax.swing.WindowConstants.DO_NOTHING_ON_CLOSE);
		this.setTitle("");
		panel1.add(jPanel1, new GridBagConstraints(0, 1, 2, 1, 1.0, 1.0,
				GridBagConstraints.CENTER, GridBagConstraints.BOTH, new Insets(
						0, 0, 0, 0), 269, 0));
		jPanel1.add(okButton, null);
		jPanel1.add(cancelButton, null);
		panel1.add(jScrollPane1, new GridBagConstraints(1, 0, 1, 1, 1.0, 1.0,
				GridBagConstraints.CENTER, GridBagConstraints.BOTH, new Insets(
						0, 0, 0, 0), 54, 133));
		jScrollPane1.getViewport().add(jList1, null);
		this.getContentPane().add(panel1, BorderLayout.CENTER);
	}

	// public void

	// Overridden so we can exit when window is closed
	@Override
	protected void processWindowEvent(WindowEvent e) {
		if (e.getID() == WindowEvent.WINDOW_CLOSING) {
			cancel();
		}
		super.processWindowEvent(e);
	}

	// Close the dialog
	void cancel() {
		dispose();
	}

	public boolean okButtonPresses() {
		return okButtonPressed;
	}

	public String getElementAt(int index) {
		return (String) jList1.getModel().getElementAt(index);
	}

	public int getSelectedIndex(){
		return jList1.getSelectedIndex();
	}
	
}
