package gui.report;

import gui.MainPanel;

import java.awt.BorderLayout;
import java.awt.FlowLayout;
import java.awt.GridLayout;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;

import javax.swing.JButton;
import javax.swing.JPanel;
import javax.swing.JTabbedPane;

import controll.CaseEditorControll;

public class CaseEditorMainPanel extends MainPanel {

	private JTabbedPane caseEditors;

	public CaseEditorMainPanel() {
		this.setLayout(new BorderLayout());
		this.add(createButtonPanel(), "North");
		this.add(caseEditors = createCasePanel(), "Center");
	}

	public JTabbedPane getTabbedPane() {
		return caseEditors;
	}

	private JTabbedPane createCasePanel() {
		JTabbedPane reportPanel = new JTabbedPane();
		return reportPanel;
	}

	public void openNewReportEditor(CaseEditor editor, String name) {
		caseEditors.add(editor, name);
	}

	private JPanel createButtonPanel() {
		JButton create, openlocal, savelocal, openremote, saveremote;
		JPanel buttonpanel = new JPanel(new FlowLayout(FlowLayout.LEFT));
		buttonpanel.add(create = new JButton("Neue Datei"));
		create.addActionListener(new ActionListener() {
			public void actionPerformed(java.awt.event.ActionEvent arg0) {
				CaseEditorControll.createNewCase();
			};
		});
		buttonpanel.add(openremote = new JButton("Datei oeffnen"));
		openremote.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent arg0) {
				CaseEditorControll.openRemoteCase();
			}
		});
		buttonpanel.add(openlocal = new JButton("Datei importieren"));
		openlocal.addActionListener(new ActionListener() {
			public void actionPerformed(java.awt.event.ActionEvent arg0) {
				CaseEditorControll.openLocalCase();
			}
		});
		buttonpanel.add(saveremote = new JButton("Datei speichern"));
		saveremote.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent arg0) {
				CaseEditorControll.saveRemoteCase((CaseEditor) caseEditors
						.getSelectedComponent(), caseEditors.getTitleAt(caseEditors.getSelectedIndex()));

			}
		});
		buttonpanel.add(savelocal = new JButton("Datei exportieren"));
		savelocal.addActionListener(new ActionListener() {
			public void actionPerformed(java.awt.event.ActionEvent arg0) {
				CaseEditorControll.saveLocalCase((CaseEditor) caseEditors
						.getSelectedComponent());
			}
		});
		return buttonpanel;
	}

}
