package gui.report;

import java.awt.BorderLayout;
import java.awt.Color;
import java.awt.Font;
import java.awt.GridBagConstraints;
import java.awt.GridBagLayout;
import java.awt.GridLayout;
import java.awt.Insets;
import java.util.Hashtable;

import javax.swing.BorderFactory;
import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.JScrollPane;
import javax.swing.JTextField;
import javax.swing.JTextPane;

import xml.Constants;

/**
 * <p>
 * Title:
 * </p>
 * <p>
 * Description: Panel displaying all meta-information of the case
 * </p>
 * <p>
 * Copyright: Copyright (c) 2004
 * </p>
 * <p>
 * Company:
 * </p>
 * 
 * @author harasic
 * @version 1.0
 */

public class DescriptionPanel extends JPanel {

	JLabel jLabel1 = new JLabel();

	JTextPane notesPane = new JTextPane();

	JScrollPane scrollPane = new JScrollPane();

	JPanel centerPanel = new JPanel();

	private Hashtable<String, JTextField> values;

	public DescriptionPanel() {
		values = new Hashtable<String, JTextField>();
		this.setLayout(new BorderLayout());
		this.setBorder(BorderFactory.createEtchedBorder());
		scrollPane.getViewport().add(centerPanel);
		this.add(scrollPane, java.awt.BorderLayout.CENTER);
		initTable();
	}

	public String getValue(String label) {
		return values.containsKey(label) ? values.get(label).getText() : null;
	}

	public void setValue(String label, String value) {
		if (values.containsKey(label))
			values.get(label).setText(value);
	}

	void initTable() {

		JPanel reportPanel = new JPanel(new GridLayout(0, 2));
		for (int i = 0; i < Constants.CASE_DATA.length; i++) {
			reportPanel.add(new JLabel(Constants.CASE_DATA[i]));
			values.put(Constants.CASE_DATA[i], new JTextField());
			reportPanel.add(values.get(Constants.CASE_DATA[i]));
		}

		JPanel patientPanel = new JPanel(new GridLayout(0, 2));
		for (int i = 0; i < Constants.PATIENT_DATA.length; i++) {
			patientPanel.add(new JLabel(Constants.PATIENT_DATA[i]));
			values.put(Constants.PATIENT_DATA[i], new JTextField());
			patientPanel.add(values.get(Constants.PATIENT_DATA[i]));
		}

		JPanel statisticPanel = new JPanel(new GridLayout(0, 2));
		for (int i = 0; i < Constants.STATISTIC_DATA.length; i++) {
			statisticPanel.add(new JLabel(Constants.STATISTIC_DATA[i]));
			values.put(Constants.STATISTIC_DATA[i], new JTextField());
			statisticPanel.add(values.get(Constants.STATISTIC_DATA[i]));
			values.get(Constants.STATISTIC_DATA[i]).setEditable(false);
		}

		JPanel qualityPanel = new JPanel(new GridLayout(0, 2));
		for (int i = 0; i < Constants.QUALITY_DATA.length; i++) {
			qualityPanel.add(new JLabel(Constants.QUALITY_DATA[i]));
			values.put(Constants.QUALITY_DATA[i], new JTextField("Nein"));
			qualityPanel.add(values.get(Constants.QUALITY_DATA[i]));
			values.get(Constants.QUALITY_DATA[i]).setEditable(false);
		}

		JLabel l1 = new JLabel("Befunddaten");
		l1.setForeground(Color.BLUE);
		l1.setFont(new java.awt.Font("Dialog", Font.BOLD, 12));

		JLabel l2 = new JLabel("Patientendaten");
		l2.setForeground(Color.BLUE);
		l2.setFont(new java.awt.Font("Dialog", Font.BOLD, 12));

		JLabel l3 = new JLabel("Statistik");
		l3.setForeground(Color.BLUE);
		l3.setFont(new java.awt.Font("Dialog", Font.BOLD, 12));

		JLabel l4 = new JLabel("Qualitaetssicherung");
		l4.setForeground(Color.BLUE);
		l4.setFont(new java.awt.Font("Dialog", Font.BOLD, 12));

		JLabel l5 = new JLabel("Notizen");
		l5.setForeground(Color.BLUE);
		l5.setFont(new java.awt.Font("Dialog", Font.BOLD, 12));
		
		
		centerPanel.setLayout(new GridBagLayout());

		centerPanel.add(l1, new GridBagConstraints(0, 0, 1, 1, 1.0, 1.0,
				GridBagConstraints.CENTER, GridBagConstraints.BOTH, new Insets(
						5, 5, 5, 20), 0, 0));
		centerPanel.add(l2, new GridBagConstraints(0, 1, 1, 1, 1.0, 1.0,
				GridBagConstraints.CENTER, GridBagConstraints.BOTH, new Insets(
						5, 5, 5, 20), 0, 0));
		centerPanel.add(l3, new GridBagConstraints(0, 2, 1, 1, 1.0, 1.0,
				GridBagConstraints.CENTER, GridBagConstraints.BOTH, new Insets(
						5, 5, 5, 20), 0, 0));
		centerPanel.add(l4, new GridBagConstraints(0, 3, 1, 1, 1.0, 1.0,
				GridBagConstraints.CENTER, GridBagConstraints.BOTH, new Insets(
						5, 5, 5, 2), 0, 0));
		centerPanel.add(l5, new GridBagConstraints(0, 4, 1, 1, 1.0,
				1.0, GridBagConstraints.CENTER, GridBagConstraints.BOTH,
				new Insets(5, 5, 5, 20), 0, 0));
		
		
	
		
		centerPanel.add(reportPanel, new GridBagConstraints(1, 0, 8, 1, 1.0,
				1.0, GridBagConstraints.CENTER, GridBagConstraints.BOTH,
				new Insets(5, 5, 5, 20), 0, 0));
		centerPanel.add(patientPanel, new GridBagConstraints(1, 1, 8, 1, 1.0,
				1.0, GridBagConstraints.CENTER, GridBagConstraints.BOTH,
				new Insets(5, 5, 5, 20), 0, 0));
		centerPanel.add(statisticPanel, new GridBagConstraints(1, 2, 8, 1, 1.0,
				1.0, GridBagConstraints.CENTER, GridBagConstraints.BOTH,
				new Insets(5, 5, 5, 20), 0, 0));
		centerPanel.add(qualityPanel, new GridBagConstraints(1, 3, 8, 1, 1.0,
				1.0, GridBagConstraints.CENTER, GridBagConstraints.BOTH,
				new Insets(5, 5, 5, 20), 0, 0));
		centerPanel.add(notesPane, new GridBagConstraints(1, 4, 8, 1, 1.0, 1.0,
				GridBagConstraints.CENTER, GridBagConstraints.BOTH, new Insets(
						5, 5, 5, 20), 0, 0));
		// try { // qualityTable
		// TNM-Klassifikation
		/*
		 * String xml = XmlLib.generateXMLString(doc); int idx =
		 * xml.indexOf("Tumorklassifikation"); if (idx != -1) { String chunk =
		 * xml.substring(idx + 19, idx + 60); System.out.println(chunk); idx =
		 * chunk.indexOf(":"); int idx2 = chunk.indexOf(".");
		 * 
		 * qualityTable.setValueAt(chunk.substring(idx + 1, idx2), 15, 1); }
		 * else qualityTable.setValueAt("Nicht vorhanden", 15, 1);
		 */
		notesPane
				.setText("Die makroskopische Beschreibung einer Einsendung muss enthalten:\n"
						+ "- genaue Masse der Exzisate und eventuell vorhandener zusaetzlicher Fragmente\n"
						+ "- Gewicht (endokrine Organe, Tumoren, Hyterektomiepraeparate etc.)\n"
						+ "- anatomische Lokalisation einer Laesion\n"
						+ "- Groesse der Laesion\n"
						+ "- Beziehung der Laesion zu bestimmten anatomischen Strukturen\n"
						+ "- Beschaffenheit der  Ober- und Schnittflaeche, der Form, Farbe und Konsistenz der Laesion\n"
						+ "- die Art, wie eine Laesion anatomische Strukturen veraendert\n"
						+ "- Beziehung der Laesion zu den Resektionsraendern\n\n"
						+ "Die Diagnose  ist nach nationalen und internationalen Richtlinien (z.B.  WHO-Klassifikation \nder Tumoren etc.) "
						+ "unter Einbeziehung weiterer Standardisierungsvorhaben \n(Staging, Grading nach UICC etc.) abzufassen.\n");

	}
}
