package gui.search;

import similarity.documents.Result;
import tools.Enums.Section;

public class ReportInfo {

	private final String reportID;

	private String textChunk;

	private int age;

	private String gender;

	/**
	 * Result of a similarity search.
	 */
	private Result<Section> sim;

	public ReportInfo(String reportID) {
		this.reportID = reportID;
	}

	public String getReportID() {
		return this.reportID;
	}

	public void setTextChunk(String chunk) {
		this.textChunk = chunk;
	}

	public String getTextChunk() {
		return this.textChunk;
	}

	public void setAge(int age) {
		this.age = age;
	}

	public void setGender(String gender) {
		this.gender = gender;

	}

	public int getAge() {
		return this.age;
	}

	public String getGender() {
		return this.gender;
	}

	@Override
	public int hashCode() {
		return reportID.hashCode()/* + getTextChunk().hashCode()*/;
	}

	/**
	 * Set similarity info.
	 * 
	 * @param sim
	 *            similarity info
	 */
	public void setSimResult(Result<Section> sim) {
		this.sim = sim;
	}

	/**
	 * Get total similarity.
	 * 
	 * @return total similarity value
	 */
	public float getSimilarity() {
		return sim.getTotal();
	}

	/**
	 * Get similarity for a section.
	 * 
	 * @param sec
	 *            a section
	 * @return partial similarity
	 */
	public float getSimilarity(Section sec) {
		Float value = sim.getPartial(sec);

		if (value == null)
			return Float.NEGATIVE_INFINITY;
		else
			return value;
	}

	@Override
	public boolean equals(Object arg0) {

		return reportID.equals(((ReportInfo) arg0).reportID);
	}

}
