
package gui.search;

import java.util.ArrayList;

import javax.swing.ButtonGroup;
import javax.swing.JCheckBox;
import javax.swing.JPanel;
import javax.swing.JRadioButton;

import services.suchen.ReportSuchKonfiguration;
import tools.Enums.Section;

import com.jgoodies.forms.builder.PanelBuilder;
import com.jgoodies.forms.layout.CellConstraints;
import com.jgoodies.forms.layout.FormLayout;


public class ReportSucheKonfigUI
extends JPanel
{

	/* | = - = - = - = - = - = - = - = - = - = /-||=||-\ = - = - = - = - = - = - = - = - = - = | */
	/* | = == === ==== ===== ====== ======= === Fields ==== ======= ====== ===== ==== === == = | */
	/* | = - = - = - = - = - = - = - = - = - = \-||=||-/ = - = - = - = - = - = - = - = - = - = | */

	private final JRadioButton	radioButton_Und			= new JRadioButton("Und");
	private final JCheckBox		checkbox_Mikroskopie	= new JCheckBox(
															Section.MIKROSKOPIE.getDisplayName());
	private final JCheckBox		checkbox_Maroskopie		= new JCheckBox(
															Section.MAKROSKOPIE.getDisplayName());
	private final JCheckBox		checkbox_Kommentar		= new JCheckBox(
															Section.KOMMENTAR.getDisplayName());
	private final JCheckBox		checkbox_Diagnose		= new JCheckBox(
															Section.DIAGNOSE.getDisplayName());

	/* | = - = - = - = - = - = - = - = - = - = /-||=||-\ = - = - = - = - = - = - = - = - = - = | */
	/* | = == === ==== ===== ====== ======== Constructors = ======= ====== ===== ==== === == = | */
	/* | = - = - = - = - = - = - = - = - = - = \-||=||-/ = - = - = - = - = - = - = - = - = - = | */

	public ReportSucheKonfigUI() {
		FormLayout layout = new FormLayout("3dlu,p:g,3dlu,p:g", "0dlu,p");
		layout.setColumnGroups(new int[][] { { 2, 4 } });
		PanelBuilder pb = new PanelBuilder(layout, this);

		JRadioButton rb2 = new JRadioButton("Oder");

		ButtonGroup bg = new ButtonGroup();
		bg.add(radioButton_Und);
		bg.add(rb2);

		rb2.setSelected(true);

		checkbox_Mikroskopie.setSelected(true);
		checkbox_Maroskopie.setSelected(true);
		checkbox_Kommentar.setSelected(true);
		checkbox_Diagnose.setSelected(true);

		final CellConstraints cc = new CellConstraints();
		pb.addSeparator("Verknuepfung", cc.xyw(2, 2, 3));

		pb.appendRow("3dlu");
		pb.appendRow("p");
		pb.add(radioButton_Und, cc.xy(4, 4));
		pb.add(rb2, cc.xy(2, 4));

		pb.appendRow("3dlu");
		pb.appendRow("p");
		pb.appendRow("1dlu");
		pb.appendRow("p");
		pb.appendRow("1dlu");
		pb.appendRow("p");

		pb.addSeparator("Sektionen", cc.xyw(2, 6, 3));
		pb.add(checkbox_Mikroskopie, cc.xy(2, 8));
		pb.add(checkbox_Maroskopie, cc.xy(4, 8));
		pb.add(checkbox_Kommentar, cc.xy(4, 10));
		pb.add(checkbox_Diagnose, cc.xy(2, 10));
	}

	/* | = - = - = - = - = - = - = - = - = - = /-||=||-\ = - = - = - = - = - = - = - = - = - = | */
	/* | = == === ==== ===== ====== ======= === Methods === ======= ====== ===== ==== === == = | */
	/* | = - = - = - = - = - = - = - = - = - = \-||=||-/ = - = - = - = - = - = - = - = - = - = | */

	public ReportSuchKonfiguration getModel() {
		ArrayList<Section> arrayList = new ArrayList<Section>();

		if (checkbox_Mikroskopie.isSelected())
			arrayList.add(Section.MIKROSKOPIE);
		if (checkbox_Maroskopie.isSelected())
			arrayList.add(Section.MAKROSKOPIE);
		if (checkbox_Kommentar.isSelected())
			arrayList.add(Section.KOMMENTAR);
		if (checkbox_Diagnose.isSelected())
			arrayList.add(Section.DIAGNOSE);

		return new ReportSuchKonfiguration(arrayList, radioButton_Und.isSelected());
	}
}