
package gui.search;
import java.awt.event.ActionListener;
import gui.suchen.graph.OntologySelectListener;
import gui.suchen.listeners.KonzeptSelectionListener;

import java.awt.event.ActionListener;
import java.util.Collection;
import java.util.LinkedList;

import javax.swing.*;

import services.coordination.Parameter;
import services.coordination.ServiceID;
import services.suchen.FortschrittInfo;
import services.suchen.KonzeptSuchErgebnis;
import services.suchen.ReportSuchKonfiguration;
import services.suchen.SuchService;




import com.jgoodies.forms.builder.PanelBuilder;
import com.jgoodies.forms.layout.*;

import controll.MainControll;


public class ReportSucheUI
extends JPanel
implements
	OntologySelectListener
{
	/* | = - = - = - = - = - = - = - = - = - = /-||=||-\ = - = - = - = - = - = - = - = - = - = | */
	/* | = == === ==== ===== ====== ======= === Fields ==== ======= ====== ===== ==== === == = | */
	/* | = - = - = - = - = - = - = - = - = - = \-||=||-/ = - = - = - = - = - = - = - = - = - = | */

	private final KonzeptUI	konzeptUI;
	private JScrollPane		scrollPane;
private KonzeptSuchErgebnis suchErgebnis;
	/* | = - = - = - = - = - = - = - = - = - = /-||=||-\ = - = - = - = - = - = - = - = - = - = | */
	/* | = == === ==== ===== ====== ======== Constructors = ======= ====== ===== ==== === == = | */
	/* | = - = - = - = - = - = - = - = - = - = \-||=||-/ = - = - = - = - = - = - = - = - = - = | */

	public ReportSucheUI(KonzeptSuchErgebnis suchErgebnis, final SuchErgebnisUI parent) {
		// Preconditions:
		assert suchErgebnis != null;

		// Implementation:
		konzeptUI = new KonzeptUI(suchErgebnis);
		this.suchErgebnis = suchErgebnis;
		scrollPane = new JScrollPane(
			konzeptUI, ScrollPaneConstants.VERTICAL_SCROLLBAR_AS_NEEDED,
			ScrollPaneConstants.HORIZONTAL_SCROLLBAR_AS_NEEDED);
		scrollPane.setBorder(BorderFactory.createTitledBorder(" passende Konzepte: "));
		scrollPane.setOpaque(true);

		FormLayout layout = new FormLayout("f:p:g", "f:m:g,3dlu,m:n,1dlu,m:n");
		PanelBuilder pb = new PanelBuilder(layout, this);

		CellConstraints cellConstraints = new CellConstraints();
		pb.add(scrollPane, cellConstraints.xy(1, 1));

		final ReportSucheKonfigUI reportSucheKonfigUI = new ReportSucheKonfigUI();
		pb.add(reportSucheKonfigUI, cellConstraints.xy(1, 3));

		JButton button_reportsSuchen = new JButton("Befunde suchen");
		button_reportsSuchen.addActionListener(new ActionListener() {
			public void actionPerformed(java.awt.event.ActionEvent e) {
			
				MainControll.SERVICECOORDINATOR.requestService(ServiceID.SHOW_PROGRESS,new Parameter(null, new FortschrittInfo(true, "Konzepte Suchen")));
				
				ReportSuchKonfiguration konfiguration = reportSucheKonfigUI.getModel();
				Collection<String> selectedKonzepts = konzeptUI.getSelectedKonzepts();
				konfiguration.setConcepts(selectedKonzepts.toArray(new String[selectedKonzepts.size()]));

				
				
				MainControll.SERVICECOORDINATOR.requestService(
					ServiceID.PERFORM_REPORT_SEARCH, 
					
					
					new Parameter(parent,konfiguration)
					
				);
		
			
				
				
			
			}
		});

		pb.add(button_reportsSuchen, cellConstraints.xyw(1, 5, 1));
	}

	
	
	/* | = - = - = - = - = - = - = - = - = - = /-||=||-\ = - = - = - = - = - = - = - = - = - = | */
	/* | = == === ==== ===== ====== ======= === Methods === ======= ====== ===== ==== === == = | */
	/* | = - = - = - = - = - = - = - = - = - = \-||=||-/ = - = - = - = - = - = - = - = - = - = | */

	public void setListener(KonzeptSelectionListener listener) {
		// Preconditions:
		assert listener != null;

		// Implementation:
		konzeptUI.setListener(listener);
	}

	// ---------------------------------------------------------------------------------------------

	public void onOntologySelect(String url) {
		konzeptUI.addKonzept(url, true);
		scrollPane.setViewportView(scrollPane.getViewport().getView());
		JScrollBar verticalScrollBar = scrollPane.getVerticalScrollBar();
		verticalScrollBar.setValue(verticalScrollBar.getMaximum());
	}
}
