package gui.search;

import gui.suchen.graph.GrafischeSucheUI;
import gui.suchen.listeners.KonzeptSelectionListener;

import javax.swing.JPanel;
import javax.swing.JViewport;

import services.suchen.KonzeptSuchErgebnis;
import services.suchen.ReportSuchErgebnis;

import com.jgoodies.forms.builder.PanelBuilder;
import com.jgoodies.forms.layout.CellConstraints;
import com.jgoodies.forms.layout.FormLayout;

public class SuchErgebnisUI extends JPanel implements KonzeptSelectionListener {

	private final GrafischeSucheUI grafischeSucheUI = new GrafischeSucheUI();

	private final JViewport view = new JViewport();

	public SuchErgebnisUI(final KonzeptSuchErgebnis suchErgebnis) {
		// Preconditions:
		assert suchErgebnis != null;
		// Implementation:
		final ReportSucheUI reportSucheUI = new ReportSucheUI(suchErgebnis,
				this);
		reportSucheUI.setListener(this);
		grafischeSucheUI.setSelectListener(reportSucheUI);
		FormLayout layout = new FormLayout("f:max(p;150dlu):n,5dlu,f:m:g,5dlu",
				"5dlu,f:m:g");
		PanelBuilder pb = new PanelBuilder(layout, this);
		pb.add(reportSucheUI, new CellConstraints().xy(1, 2));
		view.setView(grafischeSucheUI);
		pb.add(view, new CellConstraints().xy(3, 2));

	}

	public void onConceptChosen(String externalForm) {
		if (externalForm != null) {
			if (view.getView() != grafischeSucheUI)
				view.setView(grafischeSucheUI);
			grafischeSucheUI.center(externalForm);
		}
	}

	public void setFoundReportView(ReportSuchErgebnis param) {
		view.setView(new ReportSuchErgebnisseUI(param, this));
	}

	public void setSimilarReportView(ReportSuchErgebnis param) {
		view.setView(new SimilarReportsSuchErgebnisseUI(param, this));
	}

}
