package gui.search;

import java.awt.Component;

import javax.swing.JEditorPane;
import javax.swing.JPanel;
import javax.swing.JScrollPane;
import javax.swing.JTabbedPane;
import javax.swing.JViewport;

import services.coordination.Parameter;
import services.coordination.ServiceID;
import services.coordination.ServiceProvider;
import services.suchen.FortschrittInfo;
import services.suchen.KonzeptSuchErgebnis;
import services.suchen.ReportSuchErgebnis;

import com.jgoodies.forms.builder.PanelBuilder;
import com.jgoodies.forms.layout.CellConstraints;
import com.jgoodies.forms.layout.FormLayout;

import controll.MainControll;

public class SuchErgebnisseUI extends JPanel implements ServiceProvider {
	/* | = - = - = - = - = - = - = - = - = - = /-||=||-\ = - = - = - = - = - = - = - = - = - = | */
	/*
	 * | = == === ==== ===== ====== ======= === Fields ==== ======= ====== =====
	 * ==== === == = |
	 */
	/* | = - = - = - = - = - = - = - = - = - = \-||=||-/ = - = - = - = - = - = - = - = - = - = | */

	private final JTabbedPane tabbedPane_suchErgebnisse = new JTabbedPane();

	private final JViewport viewport = new JViewport();

	/* | = - = - = - = - = - = - = - = - = - = /-||=||-\ = - = - = - = - = - = - = - = - = - = | */
	/*
	 * | = == === ==== ===== ====== ======== Constructors = ======= ====== =====
	 * ==== === == = |
	 */
	/* | = - = - = - = - = - = - = - = - = - = \-||=||-/ = - = - = - = - = - = - = - = - = - = | */

	public SuchErgebnisseUI() {
		MainControll.SERVICECOORDINATOR.registerServiceProvider(this,
				ServiceID.SHOW_FOUND_ONTOLOGIES);

		MainControll.SERVICECOORDINATOR.registerServiceProvider(this,
				ServiceID.SHOW_FOUND_REPORTS);

		MainControll.SERVICECOORDINATOR.registerServiceProvider(this,
				ServiceID.SHOW_SIMILAR_REPORTS);

		FormLayout layout = new FormLayout("f:p:g", "f:p:g,3dlu,p:n");
		PanelBuilder pb = new PanelBuilder(layout, this);

		JEditorPane editorPane = new JEditorPane();
		editorPane.setEditable(false);
		JScrollPane scrollPane_Blank = new JScrollPane();
		scrollPane_Blank.setViewportView(editorPane);

		viewport.setView(scrollPane_Blank);
		pb.add(viewport, new CellConstraints().xy(1, 1));
	}

	

	/* | = - = - = - = - = - = - = - = - = - = /-||=||-\ = - = - = - = - = - = - = - = - = - = | */
	/*
	 * | = == === ==== ===== ====== ======= === Methods === ======= ====== =====
	 * ==== === == = |
	 */
	/* | = - = - = - = - = - = - = - = - = - = \-||=||-/ = - = - = - = - = - = - = - = - = - = | */

	public void performService(ServiceID serviceID, Parameter param) {
		// Preconditions:
		// assert serviceID.equals(ServiceID.SHOW_FOUND_ONTOLOGIES);
		assert param != null;

		if (serviceID.equals(ServiceID.SHOW_FOUND_ONTOLOGIES)) {

			// Implementation:

			KonzeptSuchErgebnis suchErgebnis = (KonzeptSuchErgebnis) param.value;

			SuchErgebnisUI temp = new SuchErgebnisUI(suchErgebnis);
		//	searches.put(suchErgebnis, temp);
			Component add = tabbedPane_suchErgebnisse.add(

			suchErgebnis.getSuchBegriffe(),

			temp

			);

			tabbedPane_suchErgebnisse.setSelectedComponent(add);

			if (tabbedPane_suchErgebnisse.getTabCount() >= 1) {
				viewport.setView(tabbedPane_suchErgebnisse);
			}

		
		} else if (serviceID.equals(ServiceID.SHOW_FOUND_REPORTS)) {
			
		//	KonzeptSuchErgebnis key = (KonzeptSuchErgebnis) param.source;
			ReportSuchErgebnis result = (ReportSuchErgebnis) param.value;
((SuchErgebnisUI)(param.source)).setFoundReportView(result);
		//	searches.get(key).setFoundReportView(result);

		} else if (serviceID.equals(ServiceID.SHOW_SIMILAR_REPORTS)) {
		
			//KonzeptSuchErgebnis key = (KonzeptSuchErgebnis) param.source;
			ReportSuchErgebnis result = (ReportSuchErgebnis) param.value;
			((SuchErgebnisUI)(param.source)).setSimilarReportView(result);
		//	searches.get(key).setSimilarReportView(result);

		}
			MainControll.SERVICECOORDINATOR.requestService(
		ServiceID.SHOW_PROGRESS,new Parameter(null, new FortschrittInfo(false)));


	}
}