
package gui.statistic;

import java.util.Enumeration;
import java.util.Hashtable;
import java.util.Vector;

import org.jfree.chart.ChartFactory;
import org.jfree.chart.ChartPanel;
import org.jfree.chart.DateTitle;
import org.jfree.chart.JFreeChart;
import org.jfree.chart.plot.PlotOrientation;
import org.jfree.data.DefaultCategoryDataset;

/**
 * <p>
 * Title: StatistikLib
 * </p>
 * <p>
 * Description: Provides some functionality for StatistikPanels
 * </p>
 * <p>
 * Copyright: Copyright (c) 2004
 * </p>
 * <p>
 * Company:
 * </p>
 * 
 * @author Sebastian Tietz
 * @version 1.0
 */
public class StatistikLib
{
	

	public static ChartPanel makeMostCommonDiagChart(Hashtable data, Vector order){
		DefaultCategoryDataset dataset = new DefaultCategoryDataset();
		for (int i = 0; i < order.size(); i++){
			String uri = (String) order.get(i);
			int freq = ((Integer) data.get(uri)).intValue();
			uri = uri.split("#")[1]; // cut off namespace
			dataset.setValue(freq, null, uri);
		}

		JFreeChart barchart = ChartFactory.createBarChart3D("Haeufigste Diagnosen", "Diagnose",
			"Anzahl Faelle", dataset, PlotOrientation.VERTICAL, false, true, false);

		// this doesn't override the main title, but puts the date in the
		// bottom right.
		DateTitle dateTitle = new DateTitle();
		barchart.setTitle(dateTitle);

		return new ChartPanel(barchart);
	}

	public static ChartPanel makeAgeChart(Hashtable data){
		DefaultCategoryDataset dataset = new DefaultCategoryDataset();
		
		for (int i = 0; i < 10; i++){
			String text = new Integer(i * 10).toString() + "-" + new Integer(i * 10 + 9).toString();
			dataset.setValue((Integer) data.get(new Integer(i)), null, text);
		}

		JFreeChart barchart = ChartFactory.createBarChart3D("Altersverteilung", "Alter",
			"Anzahl Faelle", dataset, PlotOrientation.VERTICAL, false, true, false);

		
		// this doesn't override the main title, but puts the date in the
		// bottom right.
		DateTitle dateTitle = new DateTitle();
		barchart.setTitle(dateTitle);

		return new ChartPanel(barchart);
	}

	public static Vector<String> biggestTen(Hashtable hashtable){
		Hashtable h = (Hashtable) hashtable.clone();
		Vector<String> result = new Vector<String>();
		for (int i = 0; i < 10; i++){
			if (!h.isEmpty()){
				int biggest = 0;
				String elem = "";
				Enumeration e = h.keys();
				while (e.hasMoreElements()){
					String word = (String) e.nextElement();
					int key = ((Integer) h.get(word)).intValue();
					if (key > biggest){
						biggest = key;
						elem = word;
					}
				}
				result.add(elem);
				h.remove(elem);
			}
		}
		return result;
	}

}
