package gui.statistic;

import io.SQLDBAccess;

import java.awt.BorderLayout;
import java.sql.ResultSet;
import java.util.Hashtable;
import java.util.Iterator;
import java.util.Vector;

import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.JTabbedPane;

/**
 * <p>
 * Title: StatistikPanel
 * </p>
 * <p>
 * Description:
 * </p>
 * <p>
 * Copyright: Copyright (c) 2004
 * </p>
 * <p>
 * Company:
 * </p>
 * 
 * @author harasic
 * @version 1.0
 */

public class StatistikPanel extends JPanel {

	private StatistikCustomPanel custom;

	private JPanel centerPanel = new JPanel(),
			mostCommonDiagPanel = new JPanel();

	public StatistikPanel(/* ReportEditor textEditFrame */) {
		this.setLayout(new BorderLayout());
	//	JPanel jPanel1 = new JPanel();
		JTabbedPane tabbedPane = new JTabbedPane();
	//	JButton neuBerechnenButton = new JButton();
		centerPanel.setLayout(new BorderLayout());
		mostCommonDiagPanel.setLayout(new BorderLayout());
	/*	neuBerechnenButton.setText("Neu Berechnen");
		neuBerechnenButton.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent arg0) {
				neuBerechnenButton_actionPerformed();

			}
		});*/

	//	this.add(jPanel1, java.awt.BorderLayout.SOUTH);
	//	jPanel1.add(neuBerechnenButton);

		this.add(tabbedPane, java.awt.BorderLayout.CENTER);
		tabbedPane.add(centerPanel, "Altersverteilung");
		tabbedPane.add(mostCommonDiagPanel, "Haeufigste Diagnosen");

		custom = new StatistikCustomPanel();
		tabbedPane.add(custom, "Benutzerdefinierte Statistik");
		view();
	}

	private void view() {
		int males = 0;
		int females = 0;
		int totalNumberOfReports = 0;
		int numberOfCases = 0;
		double reportsPerPerson = 0.0;
		String rPP = "";
		Hashtable<Integer, Integer> age = new Hashtable<Integer, Integer>();
		Hashtable<String, Integer> diagnosis = new Hashtable<String, Integer>();
		Vector sortedDiagnosis = new Vector();

		for (int i = 0; i < 10; i++) {
			age.put(new Integer(i), new Integer(0));
		}

		// clear Panels
		centerPanel.removeAll();
		mostCommonDiagPanel.removeAll();

		// lookup in db
		try {
			 String q = "select * from Befunde";
			 ResultSet rs = SQLDBAccess.query(q);

			while (rs.next()) {
				int alter = rs.getInt(2);
				int klasse = alter / 10;
				age.put(klasse, age.get(klasse) + 1);

				if (rs.getString(3).equals("M"))
					males++;
				else
					females++;
				totalNumberOfReports += rs.getInt(5);
				numberOfCases++;
			}
			reportsPerPerson = (double) totalNumberOfReports
					/ (double) numberOfCases;
			rPP += reportsPerPerson;
			rPP = rPP.substring(0, 4); // formatting --> cut off tail
		} catch (Exception e) {
		}

		for (Iterator<String> i = SQLDBAccess.listDiseaseDiagnosis().iterator(); i
				.hasNext();) {
			String uri = i.next();
			Object exists = diagnosis.get(uri);
			if (exists == null) {
				int freq = 1;
				diagnosis.put(uri, new Integer(freq));
			} else {
				int freq = diagnosis.get(uri) + 1;
				diagnosis.put(uri, new Integer(freq));
			}
		}
		sortedDiagnosis = StatistikLib.biggestTen(diagnosis);

		mostCommonDiagPanel.add(StatistikLib.makeMostCommonDiagChart(diagnosis,
				sortedDiagnosis), java.awt.BorderLayout.CENTER);
		centerPanel.add(StatistikLib.makeAgeChart(age),
				java.awt.BorderLayout.CENTER);
		centerPanel.add(new JLabel("Berichte insgesamt: " + numberOfCases
				+ " - Maennlich: " + males + " - Weiblich: " + females
				+ " - Befunde pro Patient: " + rPP),
				java.awt.BorderLayout.SOUTH);
	}

	/*public void neuBerechnenButton_actionPerformed() {
	//	OntmanagerAccess.resetDB();
		SQLDBAccess.fillDB(null);
		view();
	}*/
}
