
package gui.suchen.graph;

import java.awt.*;
import java.awt.event.*;

import javax.swing.*;


public class ColorChooserWidget
extends JLabel
{
	private static final Cursor	HANDCURSOR	= new Cursor(Cursor.HAND_CURSOR);
	/* | = - = - = - = - = - = - = - = - = - = /-||=||-\ = - = - = - = - = - = - = - = - = - = | */
	/* | = == === ==== ===== ====== ======= === Fields ==== ======= ====== ===== ==== === == = | */
	/* | = - = - = - = - = - = - = - = - = - = \-||=||-/ = - = - = - = - = - = - = - = - = - = | */

	private ColorListener		colorListener;
	private String				titel		= "Farbe w�hlen";

	/* | = - = - = - = - = - = - = - = - = - = /-||=||-\ = - = - = - = - = - = - = - = - = - = | */
	/* | = == === ==== ===== ====== ======== Constructors = ======= ====== ===== ==== === == = | */
	/* | = - = - = - = - = - = - = - = - = - = \-||=||-/ = - = - = - = - = - = - = - = - = - = | */

	public ColorChooserWidget(Color color) {
		// Preconditions:
		assert color != null;

		// Implementation:
		setText(" ");
		setBackground(color);
		setOpaque(true);
		setCursor(HANDCURSOR);
		addMouseListener(new MouseAdapter() {
			@Override
			public void mouseReleased(MouseEvent e) {
				onClick();
			}
		});
	}

	/* | = - = - = - = - = - = - = - = - = - = /-||=||-\ = - = - = - = - = - = - = - = - = - = | */
	/* | = == === ==== ===== ====== ======= === Methods === ======= ====== ===== ==== === == = | */
	/* | = - = - = - = - = - = - = - = - = - = \-||=||-/ = - = - = - = - = - = - = - = - = - = | */

	public void setTitel(String titel) {
		this.titel = titel;
	}

	public void setColorListener(ColorListener listener) {
		// Preconditions:
		assert listener != null;

		// Implementation:
		colorListener = listener;
	}

	// ---------------------------------------------------------------------------------------------

	private void onClick() {
		Color neueFarbe = JColorChooser.showDialog(
			((JComponent) getParent()).getRootPane(), titel, getBackground());

		if (neueFarbe == null)
			return;

		setBackground(neueFarbe);

		if (colorListener != null) {
			colorListener.onColorChange(neueFarbe);
		}
	}
}