
package gui.suchen.graph;

import java.awt.Color;
import java.util.Collection;

import tools.Enums.Ontologie;
import tools.Enums.Relation;



public interface GraphUI
{
	public boolean isVisible(Ontologie ontologie);

	public boolean isVisible(Relation relation);

	public Color getOntologieForeground(Ontologie ontologie);

	public Color getOntologieBackground(Ontologie ontologie);

	public Color getRelationColor(Relation relation);

	public Collection<Relation> getAngezeigteRelationen();

	boolean getAntiAlialising();

	// ---------------------------------------------------------------------------------------------

	public void setVisibility(Ontologie ontologie, boolean visible);

	public void setColor(Ontologie ontologie, Color neueFarbe);

	public void setColor(Relation relation, Color neueFarbe);

	public void setVisibility(Relation relation, boolean visible);

	public void setForeground(Ontologie ontologie, Color neueFarbe);

	public void setAntiAlialising(boolean b);

	public void addGraphUIListener(GraphUIListener listener);

	// ---------------------------------------------------------------------------------------------

	public void updateUI(OntologyNode node);

	public void updateUI(OntologyEdge edge);

}
