
package gui.suchen.graph;

import gui.suchen.graph.MyTGPanel.EdgeID;

import java.awt.Graphics;
import java.awt.Graphics2D;
import java.util.ArrayList;
import java.util.HashSet;
import java.util.List;
import java.util.Set;

import tools.GUITools;
import tools.Enums.Relation;

import com.touchgraph.graphlayout.Edge;
import com.touchgraph.graphlayout.Node;
import com.touchgraph.graphlayout.TGPanel;

public class OntologyEdge
extends Edge
{
	/* | = - = - = - = - = - = - = - = - = - = /-||=||-\ = - = - = - = - = - = - = - = - = - = | */
	/* | = == === ==== ===== ====== ======= == Constants == ======= ====== ===== ==== === == = | */
	/* | = - = - = - = - = - = - = - = - = - = \-||=||-/ = - = - = - = - = - = - = - = - = - = | */

	private static boolean		antiAlialise	= false;

	/* | = - = - = - = - = - = - = - = - = - = /-||=||-\ = - = - = - = - = - = - = - = - = - = | */
	/* | = == === ==== ===== ====== ======= === Fields ==== ======= ====== ===== ==== === == = | */
	/* | = - = - = - = - = - = - = - = - = - = \-||=||-/ = - = - = - = - = - = - = - = - = - = | */

	private final Set<Relation>	relations		= new HashSet<Relation>();

	private final EdgeID		edgeID			= new EdgeID(from.getURL(), to.getURL());

	/* | = - = - = - = - = - = - = - = - = - = /-||=||-\ = - = - = - = - = - = - = - = - = - = | */
	/* | = == === ==== ===== ====== ======== Constructors = ======= ====== ===== ==== === == = | */
	/* | = - = - = - = - = - = - = - = - = - = \-||=||-/ = - = - = - = - = - = - = - = - = - = | */

	public OntologyEdge(Node from, Node to, Relation relation) {
		super(from, to);

		// Preconditions:
		assert from != null;
		assert to != null;
		assert relation != null;

		// Implementation:
		relations.add(relation);
	}

	/* | = - = - = - = - = - = - = - = - = - = /-||=||-\ = - = - = - = - = - = - = - = - = - = | */
	/* | = == === ==== ===== ====== ======= === Methods === ======= ====== ===== ==== === == = | */
	/* | = - = - = - = - = - = - = - = - = - = \-||=||-/ = - = - = - = - = - = - = - = - = - = | */

	public List<Relation> getRelations() {
		return new ArrayList<Relation>(relations);
	}

	public EdgeID getEdgeID() {
		return edgeID;
	}

	// ---------------------------------------------------------------------------------------------

	public static void setAntiAlialise(boolean antiAlise) {
		OntologyEdge.antiAlialise = antiAlise;
	}

	public void addRelation(Relation relation) {
		// Preconditions:
		assert relation != null;

		// Implementation:
		relations.add(relation);
	}

	public void removeRelation(Relation relation) {
		// Preconditions:
		assert relation != null;

		// Implementation:
		relations.remove(relation);
	}

	// ---------------------------------------------------------------------------------------------

	@Override
	public void paint(Graphics graphics, TGPanel tgPanel) {
		// Preconditions:
		assert graphics != null && tgPanel != null;

		// Implementation:
		final Graphics2D graphics2D = (Graphics2D) graphics;
		super.paint(antiAlialise ? GUITools.antiAlialise(graphics2D) : GUITools.deAntiAlialise(graphics2D), tgPanel);
	}

}