
package gui.suchen.graph;

import java.awt.Color;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;


public class PersistenteGraphUI
{
	/* | = - = - = - = - = - = - = - = - = - = /-||=||-\ = - = - = - = - = - = - = - = - = - = | */
	/* | = == === ==== ===== ====== ======= === Fields ==== ======= ====== ===== ==== === == = | */
	/* | = - = - = - = - = - = - = - = - = - = \-||=||-/ = - = - = - = - = - = - = - = - = - = | */

	private Map<String, Color>	ontologieBackgrounds	= new HashMap<String, Color>();
	private Map<String, Color>	ontologieForegrounds	= new HashMap<String, Color>();
	private Map<String, Color>	relationColors			= new HashMap<String, Color>();
	private List<String>		angezeigteOntologien	= new ArrayList<String>();
	private List<String>		angezeigteRelationen	= new ArrayList<String>();
	private boolean				antialialise			= false;

	/* | = - = - = - = - = - = - = - = - = - = /-||=||-\ = - = - = - = - = - = - = - = - = - = | */
	/* | = == === ==== ===== ====== ======= === Methods === ======= ====== ===== ==== === == = | */
	/* | = - = - = - = - = - = - = - = - = - = \-||=||-/ = - = - = - = - = - = - = - = - = - = | */

	public boolean getAntialialise() {
		return antialialise;
	}

	public Map<String, Color> getOntologieBackgrounds() {
		return ontologieBackgrounds;
	}

	public Map<String, Color> getRelationColors() {
		return relationColors;
	}

	public Map<String, Color> getOntologieForegrounds() {
		return ontologieForegrounds;
	}

	public List<String> getAngezeigteOntologien() {
		return angezeigteOntologien;
	}

	public List<String> getAngezeigteRelationen() {
		return angezeigteRelationen;
	}

	public Class<DefaultGraphUI> getOriginClass() {
		return DefaultGraphUI.class;
	}

	// ---------------------------------------------------------------------------------------------

	public void setAntialialise(boolean antialialise) {
		this.antialialise = antialialise;
	}

	public void setOntologieBackgrounds(Map<String, Color> ontologieBackgrounds) {
		// Preconditions:
		assert ontologieBackgrounds != null;

		// Implementation:
		this.ontologieBackgrounds = ontologieBackgrounds;
	}

	public void setRelationColors(Map<String, Color> relationColors) {
		// Preconditions:
		assert relationColors != null;

		// Implementation:
		this.relationColors = relationColors;
	}

	public void setOntologieForegrounds(Map<String, Color> ontologieForegrounds) {
		// Preconditions:
		assert ontologieForegrounds != null;

		// Implementation:
		this.ontologieForegrounds = ontologieForegrounds;
	}

	public void setAngezeigteOntologien(List<String> angezeigteOntologien) {
		// Preconditions:
		assert angezeigteOntologien != null;

		// Implementation:
		this.angezeigteOntologien = angezeigteOntologien;
	}

	public void setAngezeigteRelationen(List<String> angezeigteRelationen) {
		// Preconditions:
		assert angezeigteRelationen != null;

		// Implementation:
		this.angezeigteRelationen = angezeigteRelationen;
	}
}
