
package gui.suchen.graph;



public class TouchGraphKonfiguration
{
	/* | = - = - = - = - = - = - = - = - = - = /-||=||-\ = - = - = - = - = - = - = - = - = - = | */
	/* | = == === ==== ===== ====== ======= === Fields ==== ======= ====== ===== ==== === == = | */
	/* | = - = - = - = - = - = - = - = - = - = \-||=||-/ = - = - = - = - = - = - = - = - = - = | */

	private int		zoomValue;
	private int		hyperbolic;
	private GraphUI	graphUI;

	/* | = - = - = - = - = - = - = - = - = - = /-||=||-\ = - = - = - = - = - = - = - = - = - = | */
	/* | = == === ==== ===== ====== ======== Constructors = ======= ====== ===== ==== === == = | */
	/* | = - = - = - = - = - = - = - = - = - = \-||=||-/ = - = - = - = - = - = - = - = - = - = | */

	public TouchGraphKonfiguration(int zoomValue, int hyperbolic, GraphUI graphUI) {
		// Preconditions:
		assert zoomValue >= 0;
		assert hyperbolic >= 0;
		assert graphUI != null;

		// Implementation:
		this.hyperbolic = hyperbolic;
		this.zoomValue = zoomValue;
		this.graphUI = graphUI;
	}

	/* | = - = - = - = - = - = - = - = - = - = /-||=||-\ = - = - = - = - = - = - = - = - = - = | */
	/* | = == === ==== ===== ====== ======= === Methods === ======= ====== ===== ==== === == = | */
	/* | = - = - = - = - = - = - = - = - = - = \-||=||-/ = - = - = - = - = - = - = - = - = - = | */

	public int getZoomValue() {
		return zoomValue;
	}

	public int getHyberbolic() {
		return hyperbolic;
	}

	public GraphUI getGraphUI() {
		return graphUI;
	}
}