package io;

import java.net.MalformedURLException;
import java.net.URL;
import java.util.Hashtable;

import javax.media.jai.JAI;
import javax.media.jai.PlanarImage;

public class ImageCache {

	private static Hashtable<String, PlanarImage> imagecache = new Hashtable<String, PlanarImage>();

	private static Hashtable<String, PlanarImage> thumbcache = new Hashtable<String, PlanarImage>();
	
	
	public static PlanarImage loadImage(String key){
		return loadImageFromCache(imagecache, key);
	}
	
	public static PlanarImage loadThumb(String key){
		return loadImageFromCache(thumbcache, key);
	}
	
	private static PlanarImage loadImageFromCache(Hashtable<String, PlanarImage> cache, String key){
		if(!cache.contains(key)){
			try {
				cache.put(key,JAI.create("url", new URL(key)));
			} catch (MalformedURLException e) {
				e.printStackTrace();
			}
		}
		return cache.get(key);
	}
	
}
