package io;

import java.util.Iterator;

import org.w3c.dom.Document;
import org.w3c.dom.Element;

import tools.Enums.Namespace;

import com.hp.hpl.jena.ontology.Individual;
import com.hp.hpl.jena.ontology.OntClass;
import com.hp.hpl.jena.ontology.OntModel;
import com.hp.hpl.jena.ontology.OntModelSpec;
import com.hp.hpl.jena.rdf.model.ModelFactory;
import com.hp.hpl.jena.rdf.model.Property;
import com.hp.hpl.jena.rdql.Query;
import com.hp.hpl.jena.rdql.QueryEngine;
import com.hp.hpl.jena.rdql.QueryExecution;
import com.hp.hpl.jena.rdql.QueryResults;
import com.hp.hpl.jena.rdql.ResultBinding;

/**
 * <p>
 * Title: Database connection with Jena and Jena help functions
 * </p>
 * <p>
 * Description:
 * </p>
 * <p>
 * Copyright: Copyright (c) 2004
 * </p>
 * <p>
 * Company:
 * </p>
 * 
 * @author harasic
 * @version 1.0
 */

public class JenaLib {
	/**
	 * use OWL_DL_MEM_TRANS_INF
	 * 
	 * @author Rafael
	 */
	public static final OntModelSpec ONT_MODEL_SPEC = OntModelSpec.OWL_DL_MEM_TRANS_INF;

	private static OntModel model;

	public static void openSwpathoOntology() {

	 model = ModelFactory.createOntologyModel(ONT_MODEL_SPEC, null);
	
	model.read(
			"url:http://swpatho.ag-nbi.de/swpatho/owldata/individuals.owl"
			//"file:Z:/eclipseworkspace/swpathoold/resources/owls/individuals.owl"
				
		/* swpatho.Constants.TMP_IND_PATH */);

	

	}

	public static String query(String q) {
		Document doc = XMLAccess.getNewDocument();
		String queryString = q;
		Query query = new Query(queryString);

		// get name of arguments
		String temp = (q.split(" WHERE"))[0];
		temp = temp.split("SELECT ")[1];
		String argName = temp.split(",")[0].trim();

		// cut off ? at the beginning to get the variable name that will be
		// returned (RDQL-specific
		// question mark)
		argName = argName.substring(1).trim();

		// Need to set the source if the query does not.
		query.setSource(model);
		QueryExecution qe = new QueryEngine(query);

		Element result = doc.createElement("result");
		doc.appendChild(result);

		QueryResults results = qe.exec();
		int counter = 0;
		for (Iterator iter = results; iter.hasNext();) {
			counter++;
			ResultBinding res = (ResultBinding) iter.next();

			String line = res.get(argName).toString();

			Element conceptName = doc.createElement("conceptName");
			conceptName.setAttribute("value", line);
			result.appendChild(conceptName);
		}
		results.close();

		return XMLAccess.generateXMLString(doc);
	}

	public static String query3(String q) {
		Document doc = XMLAccess.getNewDocument();
		Query query = new Query(q);

		// get name of arguments - important: take care of sql format - ONE
		// space between two
		// argruments!!!
		String temp = (q.split(" WHERE"))[0];
		temp = temp.split("SELECT ")[1];
		String argName1 = temp.split(",")[0];
		String argName2 = temp.split(",")[1];
		String argName3 = temp.split(",")[2];

		// Need to set the source if the query does not.
		query.setSource(model);
		QueryExecution qe = new QueryEngine(query);

		Element result = doc.createElement("result");
		doc.appendChild(result);

		QueryResults results = qe.exec();

		// cut off ? at the beginning
		argName1 = argName1.trim().substring(1);
		argName2 = argName2.trim().substring(1);
		argName3 = argName3.trim().substring(1);

		int counter = 0;
		for (Iterator iter = results; iter.hasNext();) {
			counter++;
			ResultBinding res = (ResultBinding) iter.next();

			String arg1 = res.get(argName1).toString();
			String arg2 = res.get(argName2).toString();
			String arg3 = res.get(argName3).toString();

			// if it is a named class
			if ((arg1.split("#")).length > 1) {
				Element conceptName = doc.createElement("item");
				conceptName.setAttribute(argName1, arg1);
				conceptName.setAttribute(argName2, arg2);
				conceptName.setAttribute(argName3, arg3);
				result.appendChild(conceptName);
			}
		}
		results.close();

		return XMLAccess.generateXMLString(doc);
	}

	public static OntClass getClassFromString(String ontclass) {
		return model.getOntClass(ontclass);
	}

	//DIRTY WORKAROUND
	public static Individual getIndividualFromString(String individual) {

		
	
		String r = individual.replaceAll("http://swpatho.ag-nbi.de/owldata/","");
		
	
		
		return model.getIndividual(r);
	}

	public static Property getUMLSContainedByProperty() {
		return (Property) model.getResource(
				Namespace.BEFUNDBERICHT.getURI() + "UMLSConceptContainedBy")
				.as(Property.class);

	}
}
