package io;

import java.sql.Connection;
import java.sql.DriverManager;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.sql.Statement;
import java.util.Hashtable;
import java.util.Vector;

import org.apache.xpath.XPathAPI;
import org.w3c.dom.Document;
import org.w3c.dom.Node;
import org.w3c.dom.NodeList;

import xml.Case;
import xml.Constants;

public class SQLDBAccess {

	private static Connection conn;

	public static synchronized void initConnection() {
	System.err.println("CONNECTING TO MYSQL_DATABASE");
		try {
			Class.forName(io.Constants.MYSQL_DRIVER);
			conn = DriverManager.getConnection(io.Constants.MYSQL_ADDRESS,
					io.Constants.MYSQL_USERNAME, io.Constants.MYSQL_PASSWD);
			System.err.println("CONNECTION TO MYSQL_DATABASE ESTABLISHED");
		} catch (SQLException e) {
			e.printStackTrace();
		} catch (ClassNotFoundException e) {
			e.printStackTrace();
		}
	}

	public static ResultSet query(String q) {
		// assume conn is an already created JDBC connection
		Statement stmt = null;
		ResultSet rs = null;
		try {
			stmt = conn.createStatement();
			rs = stmt.executeQuery(q);
			if (rs == null) {
				System.err.println("ResultSet is null");
			}
		} catch (SQLException sqlEx) {
			sqlEx.printStackTrace();
			rs = null;
		} catch (NullPointerException e) {
			e.printStackTrace();
		}
		return rs;
	}

	public static String getNumberofReports(String patientID) {
		try {
			//System.err.println(patientID);
			String q = "select * from Befunde where patient = '" + patientID
					+ "'";
			if (patientID == null)
				return null;
			ResultSet rs = query(q);
			rs.first();
			int numberReports = 0;
			if (rs.next())
				numberReports = rs.getInt(5);
			rs.close();
			return numberReports + "";
		} catch (SQLException e) {
			e.printStackTrace();
		}
		return null;
	}

	public static String getDiagnosis(String caseID) {
		try {
		//	System.err.println(caseID);
			String q = "select * from Diagnosen where befund = '" + caseID
					+ "'";// and category =
			ResultSet rs = query(q);
			int counter = 0;
			String diags = "";
			while (rs.next()) {
				counter++;
			//	System.out.println(rs.getString(2));
		//		diags += rs.getString(2).split("#")[1] + ", ";
			}
			diags = counter + diags;
			rs.close();
			return diags;
		} catch (SQLException e) {
			e.printStackTrace();
		}
		return null;
	}

	private static void fillDBwithJena(Hashtable textChunks) {

		try {
			// read list of reports
			/*
			 * URL file = new URL(testsetFilename); BufferedReader fileInput =
			 * new BufferedReader( new InputStreamReader(file.openStream()));
			 * 
			 * String line = fileInput.readLine().trim(); while (line != null) {
			 * reports.add(line); line = fileInput.readLine();
			 * System.out.println(line); }
			 */

			// parsen und Daten rausziehen
			// 1. Diagnosen
			String result = OntmanagerAccess.getDiagnosis();
			//System.out.println(result);
			Document doc = XMLAccess.string2xml(result);
			NodeList elems = XPathAPI.selectNodeList(doc, "/result/item");
			for (int i = 0; i < elems.getLength(); i++) {
				Node elem = elems.item(i);
				String uri = XPathAPI.selectSingleNode(elem, "@diagnosis")
						.getNodeValue();
				String repID = XPathAPI.selectSingleNode(elem, "@reportID")
						.getNodeValue();
				String category = XPathAPI.selectSingleNode(elem, "@category")
						.getNodeValue();
				String individual = XPathAPI.selectSingleNode(elem,
						"@individual").getNodeValue();
				String text = "";
				if (textChunks != null) {
					final Object object = textChunks.get(individual);
					if (object != null) {
						text = object.toString();
						if (text.length() > 99) {
							text = text.substring(0, 96) + "...";
						}
					}
				}
				// System.out.println(uri + " " + repID + " " + category + " " +
				// individual + " " + text);

				String q = "insert into Diagnosen values('" + repID + "','"
						+ uri + "','" + category + "', '" + individual + "','"
						+ text + "')";
//System.out.println(q);
				
			//	OntmanagerAccess.executeSQL(q);

				// insert directly into db
				execute(q);

				// uris.add(uri);
				// freqs.add(new Integer(repID));
			}
		} catch (Exception e) {
			// TODO: handle exception
		}
	}

	
	
	
	
	
	
	
	public static void fillDB(/* JenaAccess jena, */
	Hashtable textChunks) {
		// Vector<String> reports = new Vector<String>();
		// String gender = "";
		String reportID = "";
		int numberReports = 0;
		// String patientID = "";
		// int alter = 0;
	
		//OntmanagerAccess.
		try {

			// 2. Befunde

			String[] reports = XMLDBAccess.listStoredFiles();

			
			Document doc;
			Case c;
			for (int i = 0; i < reports.length ; i++) {
			
				
				
				/*
				 * doc = XmlLib.openFile(io.Constants.TESTSET_PATHNAME +
				 * reports.get(i).toString() + ".xml");
				 */

				doc = XMLDBAccess.loadCaseFromDB(reports[i]);
				
/*
				
	
	File f = File.createTempFile("temp", ".xml");

	OutputFormat of = new OutputFormat();
	
	OutputStreamWriter out = new OutputStreamWriter(
			new FileOutputStream(f), Charset.forName("UTF-8"));

	
	of.setIndent(4);
	of.setIndenting(true);
	of.setLineWidth(80);
	new XMLSerializer(out, of).serialize(doc);
	out.flush();
	out.close();
	
	InputStreamReader in = new InputStreamReader(new FileInputStream(f),
			Charset.forName("UTF-8"));
	BufferedReader inb = new BufferedReader(in);
	
	String r="";
	String temp ="";
	while((temp = inb.readLine()) != null) 
		r+=temp+"\n";
	//System.out.println(r);
	
	//System.out.println(r);
	
	// System.out.println(Charset.forName("UTF-8"));

	*/

	//OntmanagerAccess.addReport(r);
	
				c = new Case(doc);
				
				int size = c.getCaptions().size();
				for(int j = 0; j < size; j++){
					
					System.out.println(OntmanagerAccess.addReport(XMLAccess.doReport(c,reports[i], j)));
				}
				
				
				
				
				// System.out.println(c.getNodeValue(Constants.getQueryFromLabel(Constants.PATIENT_PATIENT_GENDER)));

				// textEditFrame.openReport(doc);

				// String gender =
				// c.getNodeValue(Constants.getQueryFromLabel(Constants.PATIENT_PATIENT_GENDER));

				// String alter =
				// c.getNodeValue(Constants.getQueryFromLabel(Constants.PATIENT_PATIENT_BIRTH));

				Node alter = XPathAPI.selectSingleNode(doc, Constants
						.getQueryFromLabel(Constants.PATIENT_PATIENT_BIRTH)

				);

				Node gender = XPathAPI.selectSingleNode(doc, Constants
						.getQueryFromLabel(Constants.PATIENT_PATIENT_GENDER)

				);

				Node patientID = XPathAPI.selectSingleNode(doc, Constants
						.getQueryFromLabel(Constants.PATIENT_PATIENT_ID)

				);
				// c.getNodeValue(Constants.getQueryFromLabel(Constants.PATIENT_PATIENT_ID));

				reportID = reports[i].substring(0, reports[i].indexOf(".xml"));

				// numberReports = textEditFrame.getNrOfReports();

				numberReports = c.getCaptions().size();

				int i_alteR = (alter != null && alter.getNodeValue() != null) ? Integer
						.parseInt(alter.getNodeValue())
						: 0;

				String s_gender = (gender != null) ? gender.getNodeValue()
						: null;
				String s_patientID = (patientID != null) ? patientID
						.getNodeValue() : null;

				// save in db
				String q = "insert into Befunde values('" + reportID + "',"
						+ i_alteR + ", '" + s_gender + "', '" + s_patientID
						+ "', " + numberReports + ")";
				System.out.println(q);
			//	 OntmanagerAccess.executeSQL(q);

				// System.out.println(q);

				// insert directly into db
				// execute(q);

				// textEditFrame.closeFile();
				
				fillDBwithJena(textChunks);
				
			}

		} catch (Exception ex) {
			ex.printStackTrace();
		}
	}

	public static boolean execute(String q) {
		Statement s;
		try {
			s = conn.createStatement();
			s.executeUpdate(q);
			s.close();
		} catch (SQLException e) {
			System.out.println("Warning: " + e.getMessage());
			return false;
		}
		return true;
	}

	public static Vector<String> listGroupDiseaseDiagnosis() {
		Vector<String> diagnosis = new Vector<String>();
		String q = "select diagnose from Diagnosen where category = 'disease_or_syndrome' group by diagnose";
		ResultSet rs = query(q);
		try {
			while (rs.next())
				diagnosis.add(rs.getString(1));
			rs.close();
		} catch (SQLException e) {
			e.printStackTrace();
		}
		return diagnosis;
	}

	public static Vector<String> listGroupAntigenDiagnosis() {
		String q = "select diagnose from Diagnosen where category = 'antigen' group by diagnose";
		Vector<String> diagnosis = new Vector<String>();
		ResultSet rs = query(q);
		try {
			while (rs.next())
				diagnosis.add(rs.getString(1));
			rs.close();
		} catch (SQLException e) {
			e.printStackTrace();
		}
		return diagnosis;
	}

	public static Vector<String> listGroupFindingsDiagnosis() {
		String q = "select diagnose from Diagnosen where category = 'finding' group by diagnose";
		Vector<String> diagnosis = new Vector<String>();
		ResultSet rs = query(q);
		try {
			while (rs.next())
				diagnosis.add(rs.getString(1));
			rs.close();
		} catch (SQLException e) {
			e.printStackTrace();
		}
		return diagnosis;
	}

	public static Vector<String> listBefundeWithDiagnosis(String diagnosis) {
		String q = "select Befunde.befund from Befunde, Diagnosen where Diagnosen.befund = Befunde.befund and Diagnosen.diagnose = '"
				+ diagnosis + "'";
		Vector<String> uris = new Vector<String>();
		ResultSet rs = SQLDBAccess.query(q);
		try {
			while (rs.next())
				uris.add(rs.getString(1));
			rs.close();
		} catch (SQLException e) {
			e.printStackTrace();
		}
		return uris;
	}

	public static int getAgeFromBefund(String bid){
		int result =0;
		String q= "select age from Befunde where befund = '" + bid + "'";
		ResultSet rs = SQLDBAccess.query(q);
		try{
			if(rs.next())
				result = rs.getInt(1);
			rs.close();
		}
		catch (SQLException e){
			e.printStackTrace();
		}
		return result;
	}
	
	public static String getGenderFromBefund(String bid){
		String result = "";
		String q= "select gender from Befunde where befund = '" + bid + "'";
		ResultSet rs = SQLDBAccess.query(q);
		try{
			if(rs.next())
				result = rs.getString(1);
			rs.close();
		}
		catch (SQLException e){
			e.printStackTrace();
		}
		return result;
	}

	public static Vector<String> listDiseaseDiagnosis() {
		String q = "select diagnose from Diagnosen where category = 'disease_or_syndrome'";
		Vector<String> uris = new Vector<String>();
		ResultSet rs = SQLDBAccess.query(q);
		try {
			while (rs.next())
				uris.add(rs.getString(1));
			rs.close();
		} catch (SQLException e) {
			e.printStackTrace();
		}
		return uris;
	}

	public static void main(String[] a){
		initConnection();
		ResultSet diag = query("select * from Diagnosen");
		ResultSet befunde = query("select * from Befunde");
	
		
		//executeSQL("create table Befunde (befund VARCHAR(6) PRIMARY KEY NOT NULL,age INT,gender VARCHAR(1),patient VARCHAR(6),numberReports INT);");
		//executeSQL("create table Diagnosen (diagnose VARCHAR(200),category VARCHAR(20),individual VARCHAR(200),textChunk VARCHAR(100))");
	
		
		
		try {
			while(diag.next()){
				//System.out.println(diag.getString(2) + " " +  diag.getString(4) + " #######  " + diag.getString(5));
				String s = diag.getString(2);
				String s2 = diag.getString(4);
				String t = s.replaceAll("http://nbi.inf.fu-berlin.de/research/swpatho/owldata/" , "http://swpatho.ag-nbi.de/owldata/");
				String t2 = s2.replaceAll("http://nbi.inf.fu-berlin.de/research/swpatho/owldata/" , "http://swpatho.ag-nbi.de/owldata/");
				System.out.println(s2 + " " + t2);
			//	execute("update Diagnosen set diagnose = '" + t +"' where diagnose ='" + s+"'");
			//	execute("update Diagnosen set individual = '" + t2+"' where individual ='" + s2+"'");
			}
		} catch (SQLException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
	}
	
	
}
