package io;

import java.io.ByteArrayInputStream;
import java.io.File;
import java.io.FileInputStream;
import java.io.FileOutputStream;
import java.io.IOException;
import java.io.OutputStreamWriter;
import java.io.StringWriter;
import java.nio.charset.Charset;

import javax.xml.parsers.DocumentBuilder;
import javax.xml.parsers.DocumentBuilderFactory;
import javax.xml.parsers.ParserConfigurationException;

import org.w3c.dom.Document;
import org.w3c.dom.Element;
import org.xml.sax.SAXException;


import xml.Case;
import xml.Constants;

import com.sun.org.apache.xml.internal.serialize.OutputFormat;
import com.sun.org.apache.xml.internal.serialize.XMLSerializer;

public class XMLAccess {

	public static void exportCase(File path, Document cas) throws IOException {
		//FileOutputStream fout = new FileOutputStream(path);
		OutputFormat of = new OutputFormat();
	
		OutputStreamWriter out = new OutputStreamWriter(
				new FileOutputStream(path), Charset.forName("UTF-8"));

		
		
		
		of.setIndent(4);
		of.setIndenting(true);
		of.setLineWidth(80);
		new XMLSerializer(out, of).serialize(cas);
		out.flush();
		out.close();
	}

	public static Document importCase(File path) throws IOException,
			SAXException, ParserConfigurationException {
		
		return DocumentBuilderFactory.newInstance().newDocumentBuilder().parse(
				new FileInputStream(path));
	}
	
	
	public static Document string2xml(String s)
	{
		if(s == null)
			return null;
		// ACHTUNG: Hier stimmt was nicht (premature error, wahrscheinlich leerer string!

		// System.out.println(s.length());
	//	s = unescapeHTML(s, 0);
		Document doc;
		try
		{
			DocumentBuilderFactory docBuilderFactory = DocumentBuilderFactory.newInstance();
			DocumentBuilder docBuilder = docBuilderFactory.newDocumentBuilder();
//			doc = docBuilder.parse(new ByteArrayInputStream(s.getBytes("UTF-8")));
			doc = docBuilder.parse(new ByteArrayInputStream(s.getBytes()));
			return doc;
		}
		catch (Exception e)
		{
			e.printStackTrace();
		}
		return null;
	}
	
	public static String normalize(String s)
	{
		return s.toLowerCase().replaceAll("ö", "oe").replaceAll("ä", "ae")
			.replaceAll("ü", "ue").replaceAll("ß", "ss");
	}
	
	public static final String unesc(String s)
	{
		s = s.replaceAll(";auml;", "ä");
		s = s.replaceAll(";Auml;", "Ä");
		s = s.replaceAll(";ouml;", "ö");
		s = s.replaceAll(";Ouml;", "Ö");
		s = s.replaceAll(";uuml;", "ü");
		s = s.replaceAll(";Uuml;", "Ü");
		s = s.replaceAll(";szlig;", "ß");

		return s;
	}
	
	public static Document getNewDocument()
	{
		Document doc;
		try
		{
			DocumentBuilderFactory docBuilderFactory = DocumentBuilderFactory.newInstance();
			DocumentBuilder docBuilder = docBuilderFactory.newDocumentBuilder();
			doc = docBuilder.newDocument();
			return doc;
		}
		catch (Exception e)
		{
			e.printStackTrace();
		}
		return null;

	}
	
	public static String generateXMLString(Document doc)
	{

		StringWriter strWriter = null;
		XMLSerializer probeMsgSerializer = null;
		OutputFormat outFormat = null;
		String xmlStr = "";
		try
		{
			probeMsgSerializer = new XMLSerializer();
			strWriter = new StringWriter();
			outFormat = new OutputFormat();

			// Setup format settings
			// outFormat.setEncoding("UTF-8");
			outFormat.setVersion("1.0");
			outFormat.setIndenting(true);
			outFormat.setIndent(4);

			// Define a Writer
			probeMsgSerializer.setOutputCharStream(strWriter);

			// Apply the format settings
			probeMsgSerializer.setOutputFormat(outFormat);

			// Serialize XML Document
			probeMsgSerializer.serialize(doc);
			xmlStr = strWriter.toString();
			strWriter.close();

		}
		catch (IOException ioEx)
		{
			ioEx.printStackTrace();
		}
		return xmlStr;
	}
	

	
	
	public static String doReport(Case c, String caseReportName, int pos)
	{
		Document doc = getNewDocument();
		Element report = doc.createElement("report");
		doc.appendChild(report);
		report.setAttribute("belongsToCaseReport", caseReportName);

		
		
		Element diagnosis = doc.createElement(Constants.SECTION);
		report.appendChild(diagnosis);
		diagnosis.setAttribute("name", "diagnosis");
		diagnosis.setAttribute("value", 
				
				c.getContent(Constants.REPORT_CRITICAL, pos).trim()
				
				//tab.getBerichtText().trim()
				
		);

		Element micro = doc.createElement(Constants.SECTION);
		report.appendChild(micro);
		micro.setAttribute("name", "micro");
		micro.setAttribute("value", 
				
				c.getContent(Constants.REPORT_MICRO, pos).trim()	
			//	tab.getMikroText().trim()
				
		
		);

		Element macro = doc.createElement(Constants.SECTION);
		report.appendChild(macro);
		macro.setAttribute("name", "macro");
		macro.setAttribute("value",
			//	tab.getMakroText().trim()
				c.getContent(Constants.REPORT_MAKRO, pos).trim()
		);

		Element comment = doc.createElement(Constants.SECTION);
		report.appendChild(comment);
		comment.setAttribute("name", "comment");
		comment.setAttribute("value",
			//	tab.getKommentarText().trim()
				
		c.getContent(Constants.REPORT_COMMENT, pos).trim()
		);

		// System.out.println(XmlLib.generateXMLString(doc));
		String s = generateXMLString(doc);

		//s = escapeHTMLcontent(s);

		// System.out.println("Send to Web Service: " + s);

	//	String res = Singletons.THE_JENA_ACCESS().addReport(s);
		// System.out.println("Result------------------------------------------------\n" + res);

		return s;

	}
	
	
}
