package io;

import java.io.File;
import java.io.FileFilter;
import java.io.FileOutputStream;
import java.io.IOException;
import java.io.OutputStreamWriter;
import java.nio.charset.Charset;
import java.util.HashSet;
import java.util.Hashtable;

import javax.xml.parsers.ParserConfigurationException;

import org.apache.xindice.client.xmldb.services.CollectionManager;
import org.w3c.dom.Document;
import org.xml.sax.SAXException;
import org.xmldb.api.DatabaseManager;
import org.xmldb.api.base.Collection;
import org.xmldb.api.base.Database;
import org.xmldb.api.base.Resource;
import org.xmldb.api.base.XMLDBException;
import org.xmldb.api.modules.XMLResource;

public class XMLDBAccess {

	static CollectionManager service;

	static Collection col;

	public static synchronized void initConnection() {

		try {
			System.err.println("CONNECTING TO XML_DATABASE");
			Class c = Class.forName(Constants.XINDICE_DRIVER);
			col = null;
			Database database = (Database) c.newInstance();
			DatabaseManager.registerDatabase(database);

			col = DatabaseManager.getCollection(Constants.XINDICE_URI
					+ Constants.XINDICE_REPORT_PATH

			);
			service = (CollectionManager) col.getService("CollectionManager",
					"1.0");
		} catch (ClassNotFoundException e) {
			e.printStackTrace();
		} catch (InstantiationException e) {
			e.printStackTrace();
		} catch (IllegalAccessException e) {
			e.printStackTrace();
		} catch (XMLDBException e) {
			e.printStackTrace();
		}
		System.err.println("CONNECTION TO XML_DATABASE ESTABLISHED");

	}

	private static void closeConnection() throws Exception {
		if (col != null) {
			col.close();
		}
	}

	public static void main(String[] args) throws Exception {

		try {

			initConnection();
			String[] res = col.listResources();
			for (int i = 0; i < res.length; i++) {
				System.out.println(res[i]);
			}
			String collectionName = "test";

			// Build up the Collection XML configuration.
			String collectionConfig = "<collection compressed=\"true\" "
					+ "            name=\""
					+ collectionName
					+ "\">"
					+ "   <filer class=\"org.apache.xindice.core.filer.BTreeFiler\"/>"
					+ "</collection>";

			/*
			 * service.createCollection(collectionName, DOMParser
			 * .toDocument(collectionConfig));
			 */

			File f = new File(
					"Z:/eclipseworkspace/swpathoold/material/Testset/testset1");
			File[] files = f.listFiles(new FileFilter() {
				public boolean accept(File arg0) {
					return arg0.getName().endsWith(".xml");
				}
			});
			Document[] d = new Document[files.length];
			for (int i = 0; i < files.length; i++) {

				saveCaseToDB(files[i].getName(), XMLAccess.importCase(files[i]));

			}

			// service.dropCollection(collectionName);
			/*
			 * String[] bla = service.listXMLObjects(); for(int i= 0; i <
			 * bla.length; i++){ System.out.println(bla[i]); }
			 */

		} catch (XMLDBException e) {
			e.printStackTrace();
			System.err.println("XML:DB Exception occured " + e.errorCode);
		} finally {
			closeConnection();
		}
	}

	public static synchronized String[] listStoredFiles() {
		try {
			return col.listResources();
		} catch (XMLDBException e) {
			e.printStackTrace();
		}
		return null;
	}

	public static void saveCaseToDB(String title, Document cas) {
		String[] names = listStoredFiles();
		HashSet<String> hs = new HashSet<String>();
		for (int i = 0; i < names.length; i++) {
			hs.add(names[i]);
		}
		String s_name = "000000.xml";
		if (title.equals("Neuer Bericht") && !hs.contains(title)) {
			long name = 0;
			while (hs.contains(s_name + ".xml")) {
				name++;
				s_name = Long.toString(name);
				while (s_name.length() < 5)
					s_name = "0" + s_name;
				s_name += ".xml";
			}
		} else {
			s_name = title;
		}

		try {
			if (hs.contains(s_name)) {
				Resource document = col.getResource(s_name);
				col.removeResource(document);
			}
			XMLResource document = (XMLResource) col.createResource(s_name,
					"XMLResource");
			document.setContentAsDOM(cas.getDocumentElement());
			col.storeResource(document);
		} catch (XMLDBException e) {
			e.printStackTrace();
		}
		System.err.println("Document " + s_name + " stored");
	}

	private static Hashtable<String, Document> cache = new Hashtable<String, Document>();

	public static Document loadCaseFromDB(String id) {
		try {
			if (cache.contains(id))
				return cache.get(id);
			else {
				XMLResource document = (XMLResource) col.getResource(id);
				if (document == null)
					return null;
				File f = File.createTempFile("temp", ".xml");
				OutputStreamWriter out = new OutputStreamWriter(
						new FileOutputStream(f), Charset.forName("UTF-8"));
				out.write(document.getContent().toString());
				out.close();
				cache.put(id, XMLAccess.importCase(f));
				return cache.get(id);
			}
		} catch (XMLDBException e) {
			e.printStackTrace();
		} catch (SAXException e) {
			e.printStackTrace();
		} catch (IOException e) {
			e.printStackTrace();
		} catch (ParserConfigurationException e) {
			e.printStackTrace();
		}
		return null;
	}
}