
package services.suchen;

import java.util.Collection;

import tools.Enums.Section;

public class ReportSuchKonfiguration
{

	public enum Sortiermodus
	{
        NACH_AEHNLICHKEIT("Ähnlichkeit"),
        NACH_AEHNLICHKEIT_MIKR("Ähnlichkeit in "+Section.MIKROSKOPIE.getDisplayName()),
        NACH_AEHNLICHKEIT_MAKR("Ähnlichkeit in "+Section.MAKROSKOPIE.getDisplayName()),
        NACH_AEHNLICHKEIT_DIAG("Ähnlichkeit in "+Section.DIAGNOSE.getDisplayName()),
        NACH_AEHNLICHKEIT_KOMM("Ähnlichkeit in "+Section.KOMMENTAR.getDisplayName()),
		NACH_ID("ID"),
		NACH_ALTER("Alter"),
		NACH_GESCHLECHT("Geschlecht");

		private final String	displayName;

		Sortiermodus(String displayName) {
			this.displayName = displayName;
		}

		@Override
		public String toString() {
			return displayName;
		}
	}

	/* | = - = - = - = - = - = - = - = - = - = /-||=||-\ = - = - = - = - = - = - = - = - = - = | */
	/* | = == === ==== ===== ====== ======= === Fields ==== ======= ====== ===== ==== === == = | */
	/* | = - = - = - = - = - = - = - = - = - = \-||=||-/ = - = - = - = - = - = - = - = - = - = | */

	private final boolean				undVerknuepft;

	private final Collection<Section>	suchSections;

	private String[]					konzepte;

	private Sortiermodus				sortiermodus	= Sortiermodus.NACH_ID;

	/* | = - = - = - = - = - = - = - = - = - = /-||=||-\ = - = - = - = - = - = - = - = - = - = | */
	/* | = == === ==== ===== ====== ======== Constructors = ======= ====== ===== ==== === == = | */
	/* | = - = - = - = - = - = - = - = - = - = \-||=||-/ = - = - = - = - = - = - = - = - = - = | */

	public ReportSuchKonfiguration(Collection<Section> suchSections, boolean undVerknuepft) {
		this.undVerknuepft = undVerknuepft;
		this.suchSections = suchSections;

	}

	/* | = - = - = - = - = - = - = - = - = - = /-||=||-\ = - = - = - = - = - = - = - = - = - = | */
	/* | = == === ==== ===== ====== ======= === Methods === ======= ====== ===== ==== === == = | */
	/* | = - = - = - = - = - = - = - = - = - = \-||=||-/ = - = - = - = - = - = - = - = - = - = | */

	public Collection<Section> getSuchSections() {
		return this.suchSections;
	}

	public boolean isUndVerknuepft() {
		return undVerknuepft;
	}

	public String[] getKonzepte() {
		return konzepte;
	}

	// ---------------------------------------------------------------------------------------------

	public void setConcepts(String... konzepte) {
		// Preconditions:
		assert konzepte != null;

		// Implementation:
		this.konzepte = konzepte;
	}

	public Sortiermodus getSortiermodus() {
		return sortiermodus;
	}

	public void setSortiermodus(Sortiermodus modus) {
		sortiermodus = modus;
	}
}
