package similarity.concepts.matcher.string;

import api.AbstractStringMetric;

/**
 * This is a generic wrapper-class for all metrics of the SimMetrics framework. 
 * 
 * @author Rafael Grote <grote@inf.fu-berlin.de>
 */
public class GenericStringMatcher extends AbstractStringMatcher
{
    /**
     * Used metric from SimMetrics
     */
    private final AbstractStringMetric metric;
    
    /**
     * Create string matcher for the given metric.
     * 
     * @param metric a metric of the SimMetrics framework
     */
    protected GenericStringMatcher(AbstractStringMetric metric)
    {
        this.metric = metric;
    }
    
    protected float calcStringSim(String string1, String string2)
    {
        return metric.getSimilarity(string1,string2);
    }

    @Override
    public String toString()
    {
        return metric.getShortDescriptionString();
    }
}
