package similarity.concepts.matcher.string;

import similarity.concepts.matcher.Matcher;
import similaritymetrics.*;

/**
 * Factory for all metrics of the SimMetrics framework.
 * 
 * @author Rafael Grote <grote@inf.fu-berlin.de>
 */
public class StringMatcherFactory
{
    public static Matcher createBlockDistanceMatcher()
    {
        return new GenericStringMatcher(new BlockDistance());
    }
    
    public static Matcher createChapmanLengthDeviationMatcher()
    {
        return new GenericStringMatcher(new ChapmanLengthDeviation());
    }
    
    public static Matcher createChapmanMatchingSoundexMatcher()
    {
        return new GenericStringMatcher(new ChapmanMatchingSoundex());
    }
    
    public static Matcher createChapmanMeanLengthMatcher()
    {
        return new GenericStringMatcher(new ChapmanMeanLength());
    }
    
    public static Matcher createCosineSimilarityMatcher()
    {
        return new GenericStringMatcher(new CosineSimilarity());
    }
    
    public static Matcher createDiceSimilarityMatcher()
    {
        return new GenericStringMatcher(new DiceSimilarity());
    }
    
    public static Matcher createEuclideanDistanceMatcher()
    {
        return new GenericStringMatcher(new EuclideanDistance());
    }
    
    public static Matcher createJaccardSimilarityMatcher()
    {
        return new GenericStringMatcher(new JaccardSimilarity());
    }
    
    public static Matcher createJaroMatcher()
    {
        return new GenericStringMatcher(new Jaro());
    }
    
    public static Matcher createJaroWinklerMatcher()
    {
        return new GenericStringMatcher(new JaroWinkler());
    }
    
    public static Matcher createLevenshteinMatcher()
    {
        return new GenericStringMatcher(new Levenshtein());
    }
    
    /*public static Matcher createLevensteinMatcher()
    {
        return new GenericStringMatcher(new Levenstein());
    }*/
    
    public static Matcher createMatchingCoefficientMatcher()
    {
        return new GenericStringMatcher(new MatchingCoefficient());
    }
    
    public static Matcher createMongeElkanMatcher()
    {
        return new GenericStringMatcher(new MongeElkan());
    }
    
    public static Matcher createNeedlemanWunchMatcher()
    {
        return new GenericStringMatcher(new NeedlemanWunch());
    }
    
    public static Matcher createOverlapCoefficientMatcher()
    {
        return new GenericStringMatcher(new OverlapCoefficient());
    }
    
    public static Matcher createQGramsDistanceMatcher()
    {
        return new GenericStringMatcher(new QGramsDistance());
    }
    
    public static Matcher createSmithWatermanMatcher()
    {
        return new GenericStringMatcher(new SmithWaterman());
    }
    
    public static Matcher createSmithWatermanGotohMatcher()
    {
        return new GenericStringMatcher(new SmithWatermanGotoh());
    }
    
    public static Matcher createSmithWatermanGotohWindowedAffineMatcher()
    {
        return new GenericStringMatcher(new SmithWatermanGotohWindowedAffine());
    }
    
    public static Matcher createSoundexMatcher()
    {
        return new GenericStringMatcher(new Soundex());
    }
    
}
