
package tools;

import java.awt.*;


/**
 * Implementiert das Antialialising fuer Graphics2D - Objekte
 */

public class GUITools
{
	/* | = - = - = - = - = - = - = - = - = - = /-||=||-\ = - = - = - = - = - = - = - = - = - = | */
	/* | = == === ==== ===== ====== ======== Static Methods ======= ====== ===== ==== === == = | */
	/* | = - = - = - = - = - = - = - = - = - = \-||=||-/ = - = - = - = - = - = - = - = - = - = | */

	public static Graphics2D antiAlialise(Graphics2D graphics) {
		// Preconditions:
		assert graphics != null;

		// Implementation:
		return antiAlialise(graphics, true);
	}

	public static Graphics2D deAntiAlialise(Graphics2D graphics) {
		// Preconditions:
		assert graphics != null;

		// Implementation:
		return antiAlialise(graphics, false);
	}

	public static Graphics2D antiAlialise(Graphics2D graphics, boolean antiAlialise) {
		// Preconditions:
		assert graphics != null;

		// Implementation:
		graphics.setRenderingHint(RenderingHints.KEY_ANTIALIASING, antiAlialise
			? RenderingHints.VALUE_ANTIALIAS_ON
			: RenderingHints.VALUE_ANTIALIAS_OFF);

		setTextAntiAlialise(graphics, antiAlialise);
		return graphics;
	}

	public static void setTextAntiAlialise(Graphics2D graphics, boolean antiAlialise) {
		// Preconditions:
		assert graphics != null;

		// Implementation:
		graphics.setRenderingHint(RenderingHints.KEY_TEXT_ANTIALIASING, antiAlialise
			? RenderingHints.VALUE_TEXT_ANTIALIAS_ON
			: RenderingHints.VALUE_TEXT_ANTIALIAS_OFF);
	}
}
