
package tools;

import java.util.concurrent.ThreadFactory;


public class LowPriorityThreadFactory
implements
	ThreadFactory
{

	/* | = - = - = - = - = - = - = - = - = - = /-||=||-\ = - = - = - = - = - = - = - = - = - = | */
	/* | = == === ==== ===== ====== ======= === Fields ==== ======= ====== ===== ==== === == = | */
	/* | = - = - = - = - = - = - = - = - = - = \-||=||-/ = - = - = - = - = - = - = - = - = - = | */

	private final ThreadFactory	delegateFactory;

	/* | = - = - = - = - = - = - = - = - = - = /-||=||-\ = - = - = - = - = - = - = - = - = - = | */
	/* | = == === ==== ===== ====== ======== Constructors = ======= ====== ===== ==== === == = | */
	/* | = - = - = - = - = - = - = - = - = - = \-||=||-/ = - = - = - = - = - = - = - = - = - = | */

	public LowPriorityThreadFactory(ThreadFactory factory) {
		// Preconditions:
		assert factory != null;

		// Implementation:
		this.delegateFactory = factory;
	}

	/* | = - = - = - = - = - = - = - = - = - = /-||=||-\ = - = - = - = - = - = - = - = - = - = | */
	/* | = == === ==== ===== ====== ======= === Methods === ======= ====== ===== ==== === == = | */
	/* | = - = - = - = - = - = - = - = - = - = \-||=||-/ = - = - = - = - = - = - = - = - = - = | */

	public Thread newThread(Runnable runnable) {
		// Preconditions:
		assert runnable != null;

		// Implementation:
		Thread newThread = delegateFactory.newThread(runnable);
		newThread.setPriority(Thread.MIN_PRIORITY);
		newThread.setDaemon(true);
		return newThread;
	}
}
