package xml;

import java.util.Hashtable;

public class Constants {

	public static final String SECTION = "section", CAPTION = "caption",
			PARAGRAPH = "paragraph", CONTENT = "content";

	public static final String XML_TOPNODE = "/levelone";

	public static final String BODY = XML_TOPNODE + "/body";

	public static final String HEADER = XML_TOPNODE
			+ "/clinical_document_header";

	private static final Hashtable<String, String> queryStrings = new Hashtable<String, String>();

	public static final String getQueryFromLabel(String label) {
		return queryStrings.get(label);
	}

	public static final String REPORT_MAKRO = "Makroskopie",
			REPORT_MICRO = "Mikroskopie", REPORT_COMMENT = "Kommentar",
			REPORT_CRITICAL = "Kritischer_Bericht";

	public static final String CASE_REPORT_ID = "Befund-ID",
			CASE_REPORT_DATE = "Befunddatum", CASE_CASE_ID = "Fall-ID",
			CASE_CASE_DATE = "Falldatum", CASE_FIRST_DOCTOR = "Erster Arzt",
			CASE_SECOND_DOCTOR = "Zweiter Arzt",
			CASE_THIRD_DOCTOR = "Dritter Arzt", CASE_SENDER = "Einsender";

	public static final String PATIENT_PATIENT_ID = "Patienten-ID",
			PATIENT_PATIENT_NAME = "Name des Patienten",
			PATIENT_PATIENT_BIRTH = "Geburtsjahr",
			PATIENT_PATIENT_GENDER = "Geschlecht",
			PATIENT_KOSTENTRAEGER = "Kostenträger",
			PATIENT_ENTRY_NUMBER = "Eingangsnummer";

	public static final String STATISTIC_NUMBEROFREPORTS = "Anzahl Befunde",
			PATIENT_NUMBEROFDIAGNOSIS = "Anzahl Diagnosen",
			PATIENT_AVERAGE_TIME_GAP = "Mittlerer Zeitabstand zwischen Befunden";

	public static final String QUALITY_PATIENT_ID = "Patientennummer",
			QUALITY_DEMOGRAPHIC_VALUES = "demografische Angaben (Name, Geburtsjahr, Geschlecht)",
			QUALITY_CASE_ID = "Fallnummer",
			QUALITY_ENTRY_NUMBER = "Eingangsnummer ",
			QUALITY_CASE_DATE = "Falldatum ", QUALITY_SENDER = "Einsender ",
			QUALITY_KOSTENTRAEGER = "Kostenträger ",
			QUALITY_REPORT_ID = "Befundnummer",
			QUALITY_REPORT_DATE = "Befunddatum ",
			QUALITY_DOCTORS = "befundende Ärzte (Arzt 1-3)",
			QUALITY_MAKRO = "Makroskopische Beschreibung",
			QUALITY_MIKRO = "Mikroskopische Beschreibung",
			QUALITY_COMMENT = "Kommentar",
			QUALITY_CRITICAL = "Histopathologische Diagnose",
			QUALITY_SCNELLSCHNITT = "Schnellschnittdiagnose",
			QUALITY_TNM = "TNM-Klassifikation";

	public static final String[] QUALITY_DATA = new String[] {
			QUALITY_PATIENT_ID, QUALITY_DEMOGRAPHIC_VALUES, QUALITY_CASE_ID,
			QUALITY_ENTRY_NUMBER, QUALITY_CASE_DATE, QUALITY_SENDER,
			QUALITY_KOSTENTRAEGER, QUALITY_REPORT_ID, QUALITY_REPORT_DATE,
			QUALITY_DOCTORS, QUALITY_MAKRO, QUALITY_MIKRO, QUALITY_COMMENT,
			QUALITY_CRITICAL, QUALITY_SCNELLSCHNITT, QUALITY_TNM };

	public static final String[] CASE_DATA = new String[] { CASE_REPORT_ID,
			CASE_REPORT_DATE, CASE_CASE_ID, CASE_CASE_DATE, CASE_FIRST_DOCTOR,
			CASE_SECOND_DOCTOR, CASE_THIRD_DOCTOR, CASE_SENDER };

	public static final String[] PATIENT_DATA = new String[] {
			PATIENT_PATIENT_ID, PATIENT_PATIENT_NAME, PATIENT_PATIENT_BIRTH,
			PATIENT_PATIENT_GENDER, PATIENT_KOSTENTRAEGER, PATIENT_ENTRY_NUMBER };

	public static final String[] STATISTIC_DATA = new String[] {
			STATISTIC_NUMBEROFREPORTS, PATIENT_NUMBEROFDIAGNOSIS,
			PATIENT_AVERAGE_TIME_GAP };

	public static final String[] REPORT_DATA = new String[] { REPORT_MAKRO,
			REPORT_MICRO, REPORT_COMMENT, REPORT_CRITICAL };

	public static String[] sections = new String[] { REPORT_MAKRO,
			REPORT_CRITICAL, REPORT_COMMENT, REPORT_MICRO,
			"Schnellschnittdiagnose", "Mikroskopisch-zytologischer_Befund",
			"Klinische_Angaben" ,"Diagnose"};

	static {
		queryStrings.put(CASE_REPORT_ID, HEADER + "/id/@EX");
		queryStrings.put(CASE_REPORT_DATE, HEADER + "/origination_dttm/@V");
		queryStrings.put(CASE_CASE_ID, HEADER + "/patient_encounter/id/@EX");
		queryStrings.put(CASE_CASE_DATE, HEADER
				+ "/patient_encounter/encounter_tmr/@V");
		queryStrings.put(CASE_FIRST_DOCTOR, HEADER
				+ "/legal_authenticator/person/id/@EX");
		queryStrings.put(CASE_SECOND_DOCTOR, HEADER
				+ "/authenticator/person/id/@EX");
		queryStrings.put(CASE_THIRD_DOCTOR, HEADER
				+ "/originator/person/id/@EX");
		queryStrings.put(CASE_SENDER, HEADER
				+ "/intended_recipient/person/id/@EX");

		queryStrings.put(PATIENT_PATIENT_ID, HEADER + "/patient/person/id/@EX");
		queryStrings.put(PATIENT_PATIENT_NAME, HEADER
				+ "/patient/person/person_name/nm/FAM/@V");
		queryStrings.put(PATIENT_PATIENT_BIRTH, HEADER
				+ "/patient/birth_dttm/@V");
		queryStrings.put(PATIENT_PATIENT_GENDER, HEADER
				+ "/patient/administrative_gender_cd/@V");
	}

}
